// Civilian1.cxx
//
////////////////////////////////////////////////////////////////////////////////

#include <values.h>

#include "Civilian1.hxx"

#define DEBUG
#define TIME 60
#define PAST_MAX 20
#define ESCAPE 4
#define FIND_RANGE 10000.0
#define PATH_PARTITION 10
#define PATH_RANGE 10000.0
#define DISTANCE 30000.0

using namespace std;
using namespace Rescue;

// ȯ
int rand_gen(int num) 
{
  static int count;
  srand(time(0) + getpid() + count);
  count = rand();
  return (count % num);
}

/** ǳƤBuildingΥǡ */
struct TargetBuildingObjectFn : public Memory::DistanceObjectFn{
  virtual bool consider(const Object* o) const{
    return(o->type() == TYPE_BUILDING &&
           ((Building*) o)->fieryness() >= 1 &&
           ((Building*) o)->fieryness() <= 3);
  }
  TargetBuildingObjectFn(const Object* o) : DistanceObjectFn(o) {}
};

Civilian1::Civilian1(int type) : Controller(type, new Memory())
{
    m_memory = (Memory*)Controller::m_memory;
    m_path = NULL;
    escape_count = 0;
}

/** ºݤ˹ưԤ */
void Civilian1::act()
{ 
  Humanoid* myself = is_a<Humanoid>(m_self);
  if(!myself) return;     

  if(myself->hp() > 0) {  
    // ߥݥμ
    MotionlessObject* here = is_a<MotionlessObject>(m_self->position());
    if(here == 0)    // human might be on ambulance.
      return;
    
    // ǤˤȤ 
    if(is_a<Refuge>(here)) {
      m_act_policy = ACT_NEVER;
      m_call_act = false;
      // ֤ɽ
      fprintf(stderr, "[%ld] is in Refuge.\n", m_id);
      return;
    }
    // ߥݥǼ
    past.insert(past.begin(), here);
    while(past.size() > PAST_MAX) 
      past.pop_back();

    if(m_time >= 0 && m_time <= TIME) {     // ߥ졼󳫻Ϥ60ʬޤ
      if(myself->buriedness() == 0) {
	// ߥݥBuildingΤȤ
	if(here->type() == TYPE_BUILDING) {
	  Building* b = (Building*) here;
	  dash_out(b);  
	} else if(here->type() == TYPE_ROAD || here->type() == TYPE_NODE) {
	  static map<Id, bool> flag;    // Ф򸫤ȽǤ뤿Υե饰
	  
          if(flag[m_id]) { 
	    if(escape_count > 0) {
	      find_road(here, past);
	      escape_count--;
	    } else 
	      moveToRefuge(here, past);  // ƨ
	    return;
	  }
	  // ǳƤBuilding򸫤Ĥ
	  Building* target = (Building*) m_memory->find(TargetBuildingObjectFn(here),
							Memory::FUNCTION_MINIMIZE);
	  if(target) {
	    // ߥݥȥåȤΥӥȤεΥDISTANCEʲʤ
	    // ե饰ΩƤ  
	    if(distance(here, target) <= DISTANCE) {
#ifdef DEBUG
	      fprintf(stderr, "[%ld]:Oh!\n", m_id);
#endif
	      flag[m_id] = true;
              escape(here, target, past);
	      return;
	    }
	    // ߤIDδʬƤ
	    switch(((int) m_id)%2) {   
	    case 0 : 
              if(escape_count > 0) {
		find_road(here, past);
		escape_count--;
	      } else
		moveToRefuge(here, past);
	      break;
	    case 1 : 
	      moveToTarget(here, target);      // åȤΥӥζ᤯ޤǰư
	      break;
	    }
	  } else {
            if(escape_count > 0) {
	      find_road(here, past);
	      escape_count--;
	    } else 
	      moveToRefuge(here, past);
	  }
	}
      } else {
	// 
	say();
      }
    } else {
      if(myself->buriedness() == 0) {
	if(here->type() == TYPE_BUILDING) {
	  Building* bd = (Building*) here;
	  dash_out(bd);  
	} else if(here->type() == TYPE_ROAD || here->type() == TYPE_NODE) {
	  if(escape_count > 0) {
	    find_road(here, past);
	    escape_count--;
	  } else
	    moveToRefuge(here, past);
	}
      } else {
	//  
	say();
      }
    }
  } else {        // Ǥ˻ǤȤ
    m_act_policy = ACT_NEVER;
    m_call_act = false;
    // ֤ɽ
    fprintf(stderr, "[%ld]:died.\n", m_id);
  }
}

/** Message */
inline void Civilian1::say()
{
  char msg[256];
  sprintf(msg, "(request :sender (agent %ld)
                         :receiver (set (agent T1))
                         :content ((action (help))))", m_id);
  
  // ʬʳMovingObject򸫤Ĥ  
  Memory::AddObjectFn objectfn = Memory::AddObjectFn(Memory::IsClassObjectFn<MovingObject>(),
						     Memory::NotObjectFn(Memory::IsObjectObjectFn(m_self)));  
  Object** other_agents = m_memory->find_list(objectfn);
#ifdef DEBUG
  fprintf(stderr, "[%ld]:say()\n", m_id);
#endif  
  act_say_list(other_agents, msg);
  delete [] other_agents;
}

/** ƨ */
inline void Civilian1::moveToRefuge(Object* object, Past past)
{ 
  // ߤpathι
   m_path = m_memory->update_path(m_path, object,
				 Memory::IsClassObjectFn<Refuge>());  
   if(!m_path) {
     if(m_self->position() == past.front()) {
       escape_count = ESCAPE;
       return;
     }
     
     // path򸫤Ĥ
     m_path = m_memory->find_path(Memory::Location(m_self),
				  Memory::IsClassObjectFn<Refuge>());
     fprintf(stderr, "new\n");
   }
   
   // Civilianιư٤뤿ˡŪϤޤǤpathʬ䤹
   if(m_path) {
     int i = 0;
     for( ; m_path[i]; i++);
#ifdef DEBUG
     fprintf(stderr, "[%ld]:moveToRefuge\n", m_id);
     fprintf(stderr, "%ld", m_path[0]->id());
     for(i=1; m_path[i]; i++)
       fprintf(stderr, "->%ld", m_path[i]->id());
     fprintf(stderr, "\n");
#endif     
     if(i < PATH_PARTITION) {
       act_move(m_path);
     } else {
       Object** pathToRefuge = new (Object*)[PATH_PARTITION];
       
       int j = 0;
       for( ; j < PATH_PARTITION-1; j++)
	 pathToRefuge[j] = m_path[j];
       pathToRefuge[j] = NULL;
       act_move(pathToRefuge);    // ư
       delete [] pathToRefuge;
     }
   }
}

/** targetζ᤯ޤǰư */
inline void Civilian1::moveToTarget(Object* object, Object* target)
{
  // target˰ֶᤤroad򸫤Ĥ
  Road* road = (Road*) m_memory->find(Memory::AddObjectFn(Memory::DistanceObjectFn(target),
							  Memory::IsClassObjectFn<Road>()),
				      Memory::FUNCTION_MINIMIZE);
  
  bool find_road = false;       // ŪϤȤʤroad̤뤫Ĵ٤
  
  if(road->block()/road->width() != 1) 
    find_road = true; 
  
  if(find_road) {
    // ߤpathι
    m_path = m_memory->update_path(m_path, object, Memory::IsObjectObjectFn(road));
    if(!m_path)
      // path򸫤Ĥ
      m_path = m_memory->find_path(Memory::Location(m_self),
				   Memory::IsObjectObjectFn(road),
				   Memory::DistanceObjectFn(road));
    // Civilianιư٤뤿ˡŪϤޤǤpathʬ䤹
    if(m_path) {
      int i = 0;
      for( ; m_path[i]; i++);
#ifdef DEBUG
      fprintf(stderr, "[%ld]:moveToTarget\n", m_id);
      fprintf(stderr, "%ld", m_path[0]->id());
      for(i=1; m_path[i]; i++)
	fprintf(stderr, "->%ld", m_path[i]->id());
      fprintf(stderr, "\n");
#endif
      if(i < PATH_PARTITION) {
	act_move(m_path);
      } else {
	Object** pathToTarget = new (Object*)[PATH_PARTITION];
	
	int j = 0;
	for( ; j < PATH_PARTITION-1; j++)
	  pathToTarget[j] = m_path[j];
	pathToTarget[j] = NULL;
	act_move(pathToTarget);    // ư
	delete [] pathToTarget;
      }
    }
  }
}

/** ӥ뤫Ф */
inline void Civilian1::dash_out(Object* object) 
{
  // BuildingǤᤤNode򸫤Ĥ
  Memory::AddObjectFn r_objectfn = Memory::AddObjectFn(Memory::IsClassObjectFn<Node>(),
						       Memory::DistanceObjectFn(object));
  Node* node = (Node*) m_memory->find(r_objectfn, Memory::FUNCTION_MINIMIZE);
  
  // ߤpathι
  m_path = m_memory->update_path(m_path, object, Memory::IsObjectObjectFn(node));
  if(!m_path)
    // path򸫤Ĥ
    m_path = m_memory->find_path(Memory::Location(m_self),
				 Memory::IsObjectObjectFn(node),
				 Memory::DistanceObjectFn(node));
  // Civilianιư٤뤿ˡŪϤޤǤpathʬ䤹
  if(m_path) {
    int i = 0;
    for( ; m_path[i]; i++);
#ifdef DEBUG
    fprintf(stderr, "[%ld]:dash_out\n", m_id);
    fprintf(stderr, "%ld", m_path[0]->id());
    for(i=1; m_path[i]; i++)
      fprintf(stderr, "->%ld", m_path[i]->id());
    fprintf(stderr, "\n");
#endif
    if(i < PATH_PARTITION) {
      act_move(m_path);
    } else {
      Object** path = new (Object*)[PATH_PARTITION];
      
      int j = 0;
      for( ; j < PATH_PARTITION-1; j++)
	path[j] = m_path[j];
      path[j] = NULL;
      act_move(path);     // ư
      delete [] path;
    }
  }
}

/** ʪǳƤʤƨ */
inline void Civilian1::escape(Object* object, Object* target, Past past)
{
  bool find_road = false;       // ŪϤȤʤroad뤫Ĵ٤
  vector<Road*> road_v;
  Road* rd = NULL;

  // object顢PATH_RANGEˤRoad򸫤Ĥ
  Memory::AddObjectFn objectfn = Memory::AddObjectFn(Memory::IsClassObjectFn<Road>(),
						     Memory::DistanceObjectFn(object));

  Memory::AddObjectFn r_objectfn = Memory::AddObjectFn(objectfn,
						       Memory::NotObjectFn(Memory::IsObjectObjectFn(object)));

  Road** road = (Road**) m_memory->find_list(r_objectfn, PATH_RANGE, Memory::FUNCTION_MINIMIZE);

  if(road != NULL) {
    int i = 0;
    while(road[i] != NULL) {
      road_v.insert(road_v.end(), road[i]);
      i++;
    }
    
    // find_listˤäƸĤäRoadshuffle
    int (*r)(int);
    r = &rand_gen;
    random_shuffle(road_v.begin(), road_v.end(), r);
    
    while(road_v.size() > 0) { 
      if(find(past.begin(), past.end(), road_v[0]) == past.end()) {  
        Memory::AddObjectFn b_objectfn = Memory::AddObjectFn(Memory::IsClassObjectFn<Building>(),
							     Memory::DistanceObjectFn(road_v[0]));
	
	Building* nearbld = (Building*) m_memory->find(b_objectfn, Memory::FUNCTION_MINIMIZE);
	
	if(!nearbld || nearbld->fieryness() != 4 &&
	   nearbld->fieryness() < ((Building*) target)->fieryness()) {
	  rd = road_v[0];
	  find_road = true;
	  break;
	}
      } else
	road_v.erase(road_v.begin());
    }    
  }
   
  if(find_road) { 
    // path򸫤Ĥ
    m_path = m_memory->find_path(Memory::Location(m_self),
				 Memory::IsObjectObjectFn(rd),
				 Memory::DistanceObjectFn(rd));
    // Civilianιư٤뤿ˡŪϤޤǤpathʬ䤹
    if(m_path) {
      int i = 0;
      for( ; m_path[i]; i++);
#ifdef DEBUG
      fprintf(stderr, "[%ld]:escape\n", m_id);
      fprintf(stderr, "%ld", m_path[0]->id());
      for(i=1; m_path[i]; i++)
	fprintf(stderr, "->%ld", m_path[i]->id());
      fprintf(stderr, "\n");
#endif     
      if(i < PATH_PARTITION) {
	act_move(m_path);
      } else {
	Object** path = new (Object*)[PATH_PARTITION];
	
	int j = 0;
	for( ; j < PATH_PARTITION-1; j++)
	  path[j] = m_path[j];
	path[j] = NULL;
	act_move(path);
	delete [] path;
      }
    }
  }
  delete [] road;
}

/** Road򸫤Ĥưư() */
inline void Civilian1::find_road(Object* object, Past past)
{
  bool find_road = false;       // ŪϤȤʤroad뤫Ĵ٤
  vector<Road*> road_v;
  Road* target = NULL;

  // object顢FIND_RANGEˤRoad򸫤Ĥ
  Memory::AddObjectFn objectfn = Memory::AddObjectFn(Memory::IsClassObjectFn<Road>(),
						     Memory::DistanceObjectFn(object));
  Memory::AddObjectFn r_objectfn = Memory::AddObjectFn(objectfn, 
						       Memory::NotObjectFn(Memory::IsObjectObjectFn(object)));

  Road** road = (Road**) m_memory->find_list(r_objectfn, FIND_RANGE, Memory::FUNCTION_MINIMIZE);

  if(road != NULL) {
    int i = 0;
    while(road[i] != NULL) {
      road_v.insert(road_v.end(), road[i]);
      i++;
    }
    
    // find_listˤäƸĤäRoadshuffle
    int (*r)(int);
    r = &rand_gen;
    random_shuffle(road_v.begin(), road_v.end(), r);
    
    while(road_v.size() > 0) {  
      if(find(past.begin(), past.end(), road_v[0]) == past.end()) { 
	target = road_v[0];
	printf("%ld \n", target->id()); 
	find_road = true;
	break;
      } else
	road_v.erase(road_v.begin());
    }    
  }  
  
  if(find_road) {
    // path򸫤Ĥ
    m_path = m_memory->find_path(Memory::Location(m_self),
				 Memory::IsObjectObjectFn(target),
				 Memory::DistanceObjectFn(target));
    // Civilianιư٤뤿ˡŪϤޤǤpathʬ䤹
    if(m_path) {
      int i = 0;
      for( ; m_path[i]; i++);
#ifdef DEBUG
      fprintf(stderr, "[%ld]:find_road\n", m_id);
      fprintf(stderr, "%ld", m_path[0]->id());
      for(i=1; m_path[i]; i++)
	fprintf(stderr, "->%ld", m_path[i]->id());
      fprintf(stderr, "\n");
#endif
      
      if(i < PATH_PARTITION) {
	act_move(m_path);
      } else {
	Object** path = new (Object*)[PATH_PARTITION];
	
	int j = 0;
	for( ; j < PATH_PARTITION; j++)
	  path[j] = m_path[j];
	path[j] = NULL;
	act_move(path);     // ư
	delete [] path;
      }
    }
  }
}

/** Υ֤ */
double Civilian1::distance(MotionlessObject* m, MotionlessObject* n) 
{
  double xDist = (m->x() - n->x());
  double yDist = (m->y() - n->y());
  return sqrt(xDist*xDist + yDist*yDist);
}
