// Civilian2.cxx
//

////////////////////////////////////////////////////////////////////////////////

#include <values.h>

#include "Civilian2.hxx"
#define DEBUG
#define PAST_MAX 20
#define PATH_PARTITION 10
#define FIND_RANGE 10000.0

using namespace std;
using namespace Rescue;

// ȯ
int rand_gen(int num) 
{
  static int count;
  srand(time(0) + getpid() + count);
  count = rand();
  return (count % num);
}

struct IsObjectID : public Memory::UniformObjectFn {
  int id;
  virtual bool consider(const Object* o) const {
    return(o->id() == id);
  }
  IsObjectID(int i) {id = i;}
};

Civilian2::Civilian2(int type) : Controller(type, new Memory())
{
    m_memory = (Memory*)Controller::m_memory;
    m_path = NULL;
    action = 0;
    f_action = 0;
}

/** ºݤ˹ưԤ */
void Civilian2::act()
{ 
  Humanoid* myself = is_a<Humanoid>(m_self);
  if(!myself) return;      

  if(myself->hp() > 0) {  
    // ߥݥμ
    MotionlessObject* here = is_a<MotionlessObject>(m_self->position());
    if(here == 0)    // human might be on ambulance.
      return;

    // ߥݥǼ
    past.insert(past.begin(), here);
    while(past.size() > PAST_MAX)
      past.pop_back();

    if(myself->buriedness() == 0) { 
      // request
      if(m_hear.hear.size() != 0 && f_action == 0) {
	ACLfipa t = m_hear.hear.front();
	m_hear.erase(0);

	if(t.content() != NULL) {
	  if(t.content()->key() == Parser::ACTION) {
	    switch(t.content()->left()->key()) {
	    case Parser::MOVE :
	      action = Parser::MOVE;
	      ACLnode* n;
	      n = t.find_s(Parser::GOAL);
	      if(n == NULL) break;
	      if(n->left()->key() == Parser::POSITION)
		goal = m_memory->find(Memory::DistanceObjectFn
				      (n->left()->left()->value(),
				       n->left()->right()->value()),
				      Memory::FUNCTION_MINIMIZE);
	      else 
		goal = m_memory->find(IsObjectID(n->left()->left()->value()),
				      Memory::FUNCTION_MINIMIZE);
	      
	      if(goal != NULL)
		f_action = 1;
	      break;
	    }
	  }
	}
      }
      // nothing request
      if(f_action == 0) 
	find_road(m_self, past);
      // act request
      if(f_action == 1) {
	m_path = m_memory->update_path(m_path, here, 
				       Memory::IsObjectObjectFn(goal));
	if(!m_path) 
	  m_path = m_memory->find_path(Memory::Location(m_self),
				       Memory::IsObjectObjectFn(goal));
	if(m_path) {
#ifdef DEBUG
	  fprintf(stderr, "[%ld]:move to %ld\n", m_id, goal->id());
	  fprintf(stderr, "%ld", m_path[0]->id());
	  for(int i=1; m_path[i]; i++)
	    fprintf(stderr, "->%ld", m_path[i]->id());
	  fprintf(stderr, "\n");
#endif
	  act_move(m_path);
	}
	if(here == goal)
	  f_action = - MOVE_COST;
      }
    }
    if(f_action < 0) 
      f_action++;
  } else {        // Ǥ˻ǤȤ
    m_act_policy = ACT_NEVER;
    m_call_act = false;
    // ֤ɽ
    fprintf(stderr, "[%ld]:died.\n", m_id);
  }
}

/** Road򸫤Ĥưư() */
inline void Civilian2::find_road(Object* object, Past past)
{
  bool find_road = false;       // ŪϤȤʤroad뤫Ĵ٤
  vector<Road*> road_v;
  Road* target = NULL;

  // object顢FIND_RANGEˤRoad򸫤Ĥ
  Memory::AddObjectFn objectfn = Memory::AddObjectFn(Memory::IsClassObjectFn<Road>(),
						     Memory::DistanceObjectFn(object));
  Memory::AddObjectFn r_objectfn = Memory::AddObjectFn(objectfn, 
						       Memory::NotObjectFn(Memory::IsObjectObjectFn(object)));

  Road** road = (Road**) m_memory->find_list(r_objectfn, FIND_RANGE, Memory::FUNCTION_MINIMIZE);

  if(road != NULL) {
    int i = 0;
    while(road[i] != NULL) {
      road_v.insert(road_v.end(), road[i]);
      i++;
    }
    
    // find_listˤäƸĤäRoadshuffle
    int (*r)(int);
    r = &rand_gen;
    random_shuffle(road_v.begin(), road_v.end(), r);
    
    while(road_v.size() > 0) {  
      if(find(past.begin(), past.end(), road_v[0]) == past.end()) { 
	target = road_v[0];
	printf("%ld \n", target->id()); 
	find_road = true;
	break; 
      } else
	road_v.erase(road_v.begin());
    }    
  }  
  
  if(find_road) {
    // path򸫤Ĥ
    m_path = m_memory->find_path(Memory::Location(m_self),
				 Memory::IsObjectObjectFn(target),
				 Memory::DistanceObjectFn(target));
    // Civilianιư٤뤿ˡŪϤޤǤpathʬ䤹
    if(m_path) {
#ifdef DEBUG
      fprintf(stderr, "[%ld]:find_road\n", m_id);
      fprintf(stderr, "%ld", m_path[0]->id());
      for(int i=1; m_path[i]; i++)
	fprintf(stderr, "->%ld", m_path[i]->id());
      fprintf(stderr, "\n");
#endif 
      act_move(m_path);
    }
  } 
}

// åʹ
void Civilian2::hear(Object *sender, const char *message)
{
  Humanoid* myself = is_a<Humanoid>(m_self);
  if(!myself) return;

   if(sender != myself){
#ifdef DEBUG
     fprintf(stderr, "[%ld]:heard %s (from %ld)\n",
	     m_id, message, sender->id());
#endif
     m_hear.add(const_cast<char *>(message));
  }
}
