// Civilian3.cxx
//
///////////////////////////////////////////////////////////////////////////////

#include "Civilian3.hxx"
#include <unistd.h>
#include <vector>
#include <algorithm>
#define SAY_RANGE 15000.0
#define SAY_LIST_SIZE 10
#define SAY_PAR_TIME  4

#define SAY_USE_LOCALID 2
#define SAY_USE_DEGREE 5

#define LOOK_RANGE 15000.0

#define PAST_MAX 20
#define FIND_RANGE 30000
#define PATH_PARTITION 10

#define HELP_COST 3
#define MOVE_COST 3
#define DEBUG

using namespace Rescue;

/** IDפ륪֥Ȥ֤ */
struct IsObjectID : public Memory::UniformObjectFn{
  int id;
  virtual bool consider(const Object* o) const {
    return (o->id() ==  id);
  }
  IsObjectID(int i){id = i;}
};

/** ǳƤBuildingΥǡ */
struct BuildingFierynessFn : public Memory::UniformObjectFn{
  int fire;
  virtual bool consider(const Object* o) const {
    return (o->type() == TYPE_BUILDING &&
	    ((Building*) o)->fieryness() >= fire);
  }
  BuildingFierynessFn(int f){fire = f;}
};

// ȯ
int rand_gen(int num){
  static int count;
  srand(time(0) + getpid()+count);
  count = rand();
  return count % num;
}

Civilian3::Civilian3(int type) : Controller(type, new Memory::Memory())
{
  m_memory = (Memory*) Controller::m_memory;
  m_path = NULL;
  f_action = 0;
  f_say = 0;
  local_id = 1;
}

void Civilian3::act()
{
  Humanoid* myself = is_a<Humanoid>(m_self);
  if(!myself) return;

  if(myself->hp() > 0) {
    MotionlessObject* here = is_a<MotionlessObject>(m_self->position());
    past.insert(past.begin(), here);
    
    ////////////////// say ///////////////////////////
    say_list_update();
    
    Object * say_t;
    if(((Humanoid*) m_self)->buriedness() > 0)
      say_t = m_self;
    else{
      say_t = m_memory->
	find(Memory::AddObjectFn
	     (Memory::AddObjectFn(Memory::DistanceObjectFn(m_self),
				  Memory::IsClassObjectFn<MovingObject>()),
	      Memory::NotObjectFn(Memory::IsObjectObjectFn(m_self))),
	     Memory::FUNCTION_MINIMIZE);
    }
    
    if(say_t != NULL &&
       Memory::DistanceObjectFn(m_self).f(say_t) > ((double)SAY_RANGE*SAY_RANGE))
      say_t = NULL;
    
    if(say_t != NULL && f_say == 0 && say_list.size() > 0){
      char *buff = new char[400];
      say_list.front().out(buff);
      act_say(say_t,buff);
#ifdef DEBUG
      fprintf(stderr, "[%ld]:say:%s\n", m_id, buff); 
#endif
      say_list.pop_front();
      delete [] buff;
      
      f_say = SAY_PAR_TIME;
    }
    
    if(f_say != 0)
      f_say--;
    
    ///////////////////  action  //////////////////////
    
    ///////////////////  requset  /////////////////////
    if( m_hear.hear.size() != 0 && f_action == 0){
      ACLfipa t = m_hear.hear.front();
      m_hear.erase(0);
      
      if(t.content() != NULL){
	if(t.content()->key() == Parser::ACTION){
	  switch(t.content()->left()->key()){
	  case Parser::MOVE :
	    action = Parser::MOVE;
	    ACLnode* n;
	    n = t.find_s(Parser::GOAL);
	    if(n == NULL) break;
	    if(n->left()->key() == Parser::POSITION)
	      goal = m_memory->find(Memory::DistanceObjectFn
				    (n->left()->left()->value(),
				     n->left()->right()->value()),
				    Memory::FUNCTION_MINIMIZE);
	    else
	      goal = m_memory->find(IsObjectID(n->left()->left()->value()),
				    Memory::FUNCTION_MINIMIZE);
	    
	    if(goal != NULL)
	      f_action = 1;
	    break;
	  case Parser::HELP :
	    ACLfipa fipa;
	    ACLnode* sender;
	    ACLnode* receiver;
	    ACLnode* content;
	    ACLnode* object;
	    ACLnode* place;
	    ACLnode* message;
	    
	    sender = m_agent(m_self->id());
	    receiver = m_tagent(1);
	    
	    if(rand_gen( SAY_USE_LOCALID) == 1){
	      object = m_object_a(Parser::AGENT,t.sender_id());
	      place = NULL;
	    }
	    else{
	      if(local[t.sender_id()] == 0){
		local[t.sender_id()] = local_id;
		local_id++;
	      }
	      object = m_tobject_a(Parser::AGENT,local[t.sender_id()]);
	    }
	    place = m_place(m_position(m_self->x()-30000+rand_gen(60000),
				       m_self->y()-30000+rand_gen(60000)));
	    content = m_state_w(object,
				m_state(Parser::BURIED,NULL),
				place,
				NULL);
	    message = m_fipa(Parser::INFORM,sender,receiver,content);
	    fipa.set_root(message);
	    
	    say_list.push_front(fipa);
	    f_action = - HELP_COST;
	  }
	}
      }  
    }

    //  noting request
    if(f_action == 0){
      find_road(m_self, past);
    }
    
    //  act request
    if(f_action == 1){
      switch(action){
      case Parser::MOVE :
	m_path = m_memory->update_path(m_path, here, 
				       Memory::IsObjectObjectFn(goal));
	if (!m_path) 
	  m_path = m_memory->find_path(Memory::Location(m_self),
				       Memory::IsObjectObjectFn(goal));
#ifdef DEBUG
	fprintf(stderr, "[%ld]:move to %ld\n", m_id, goal->id());
	fprintf(stderr, "%ld", m_path[0]->id());
	for(int i=1; m_path[i]; i++)
	  fprintf(stderr, "->%ld", m_path[i]->id());
	fprintf(stderr, "\n");
#endif
	act_move(m_path); 
	
	if (here == goal)
	  f_action = - MOVE_COST;
	break;
      default:
	f_action = 0;
      }
    }
    
    if(f_action < 0) f_action++;
  } else {        // Ǥ˻ǤȤ
    m_act_policy = ACT_NEVER;
    m_call_act = false;
    // ֤ɽ
    fprintf(stderr, "[%ld]:died.\n", m_id);
  }
}

void Civilian3::hear(Object* sender, const char* message)
{
  Humanoid* myself = is_a<Humanoid>(m_self);
  if(!myself) return;
  
  if(sender != m_self){
#ifdef DEBUG
    fprintf(stderr, "[%ld]:heard %s (from %ld)\n",
	    m_id, message, sender->id());
#endif
    m_hear.add(const_cast<char*>(message));
  }
}

/////////////////////////////////////////////////////////////////////////////
void Civilian3::say_list_update(void)
{
  Object* target = NULL;
  ACLfipa fipa;
  ACLnode* sender;
  ACLnode* receiver;
  ACLnode* content;
  ACLnode* object;
  ACLnode* degree;
  ACLnode* place;
  //ACLnode * time;
  ACLnode* message;

  if(((Humanoid*) m_self)->buriedness() > 0){
    sender = m_agent(m_self->id());
    receiver = m_tagent(1);
    content =  m_action_e(m_action(Parser::HELP,NULL,NULL,NULL),
    		  NULL,NULL);
    message = m_fipa(Parser::REQUEST,sender,receiver,content);
    fipa.set_root(message);
    
    say_list.push_front(fipa);
  }
  else{  
    target = m_memory->
      find(Memory::AddObjectFn(Memory::DistanceObjectFn(m_self),
			       BuildingFierynessFn(1)),
	   Memory::FUNCTION_MINIMIZE);
    
    if(target != NULL &&
       Memory::DistanceObjectFn(m_self).f(target)
       > ((double)LOOK_RANGE*LOOK_RANGE))
      target = NULL;
    
    if(target != NULL){
      sender = m_agent(m_self->id());
      receiver = m_tagent(1);
      
      if(rand_gen(SAY_USE_DEGREE) == 1)
	degree = m_degree(((Building *) target)->fieryness());
      else
	degree = NULL;
      
      if(rand_gen(SAY_USE_LOCALID) == 1){
	object = m_object_a(Parser::BUILDING,target->id());
	place = NULL;
      }
      else{
	if(local[target->id()] == 0){
	  local[target->id()] = local_id;
	  local_id++;
	}
	object = m_tobject_a(Parser::BUILDING,local[(int) target->id()]);
	place = m_place(m_position(target->x()-30000+rand_gen(60000),
				   target->y()-30000+rand_gen(60000)));
      }
      
      content = m_state_w(object,
			  m_state(Parser::FIRE,degree),
			  place,
			  NULL);
      message = m_fipa(Parser::INFORM,sender,receiver,content);
      fipa.set_root(message);
      
      say_list.push_front(fipa);
    }
  }
  while(say_list.size() > SAY_LIST_SIZE)
    say_list.pop_back();
}

/////////////////////////////////////////////////////////////////////////////

void Civilian3::find_road(Object* object, Past past)
{
  bool find_road;
  vector<Road*> road_v;
  Road* target = NULL;

  // find road
  Memory::AddObjectFn objectfn = 
    Memory::AddObjectFn(Memory::IsClassObjectFn<Road>(),
			Memory::DistanceObjectFn(object));
  Memory::AddObjectFn r_objectfn =
    Memory::AddObjectFn(objectfn, 
			Memory::NotObjectFn
			(Memory::IsObjectObjectFn(object)));

  Road** road = (Road**) m_memory->find_list
    (r_objectfn, FIND_RANGE, Memory::FUNCTION_MINIMIZE);

  while(past.size() > PAST_MAX)
    past.pop_back();
  
  find_road = false;
  target = NULL;
  if(road != NULL){
    int i = 0;
    while(road[i] != NULL){
      road_v.insert(road_v.end(),road[i]);
      i++;
    }

    int (*r)(int);
    r = &rand_gen; 
    random_shuffle(road_v.begin(),road_v.end(),r);

    while(road_v.size() > 0 && find_road != true){
      if(find(past.begin(), past.end(), road_v[0]) == past.end()){
	target = road_v[0];
	find_road = true;
      }
      else
	road_v.erase(road_v.begin());
    }
  }
  
  if(find_road) {
    m_path = m_memory->find_path(Memory::Location(m_self),
				 Memory::IsObjectObjectFn(target));
    // Civilianιư٤뤿ˡŪϤޤǤpathʬ䤹
    if(m_path) {
      int i = 0;
      for( ; m_path[i]; i++);
#ifdef DEBUG
      fprintf(stderr, "[%ld]:find_road\n", m_id);
      fprintf(stderr, "%ld", m_path[0]->id());
      for(i=1; m_path[i]; i++)
	fprintf(stderr, "->%ld", m_path[i]->id());
      fprintf(stderr, "\n");
#endif
      
      if(i < PATH_PARTITION) {
	act_move(m_path);
      } else {
	Object** path = new (Object*)[PATH_PARTITION];
	
	int j = 0;
	for( ; j < PATH_PARTITION; j++)
	  path[j] = m_path[j];
	path[j] = NULL;
	act_move(path);     // ư
	delete [] path;
      }
    }
  }
}
