#include "ACLsub.hxx"
#include <stdio.h>

ACLnode * m_fipa(int type,ACLnode *s,ACLnode *r,ACLnode *c)
{
  ACLnode *t;

  ACLnode *n = new ACLnode;
  n->set(type,NULL,NULL);
  t = n;
  
  if(s != NULL){
    ACLnode *x = new ACLnode; 
    x->set(Parser::SENDER,s,NULL);
    n->set_left(x);
  }

  if(r != NULL){
    ACLnode *y = new ACLnode; 
    y->set(Parser::RECEIVER,r,NULL);
    if(s != NULL)
      n->left()->set_right(y);
    else
      n->set_left(y);
  }

  if(c != NULL){
    ACLnode *z = new ACLnode; 
    z->set(Parser::CONTENT,c,NULL);
    if(r != NULL)
      n->left()->right()->set_right(z);
    else if(s != NULL)
      n->left()->set_right(z);
    else
      n->set_right(z);
  }
    return n;
}

ACLnode * m_action_e(ACLnode *a,ACLnode *b,ACLnode *c)
{
  if(a == NULL)
    return NULL;
  
  ACLnode *n = new ACLnode;
  n->set(Parser::ACTION,a,NULL);
  
  if(b != NULL){
    a->set_right(b);
    b->set_right(c);
  }
  else
    a->set_right(c);

  return n;
}

ACLnode * m_state_w(ACLnode *a,ACLnode *b,ACLnode *c,ACLnode *d)
{
  if(a == NULL || b == NULL)
    return NULL;

  ACLnode *n = new ACLnode;
  n->set(Parser::STATE,a,NULL);
  a->set_right(b);
  
  if(c != NULL){
    b->set_right(c);
    c->set_right(d);
  }
  else
    b->set_right(d);

  return n;
}

ACLnode * m_action_w(int key,ACLnode *a,ACLnode *b)
{
  if(a == NULL)
    return NULL;

  ACLnode *n = new ACLnode;
  n->set(key,a,NULL);
  a->set_right(b);
 
  return n;
}

ACLnode * m_state(int key,ACLnode *a)
{
  ACLnode *n = new ACLnode;
  n->set(key,a,NULL);
  return n;
}

ACLnode * m_action(int key,ACLnode *a,ACLnode *b,ACLnode *c)
{
  ACLnode *n = new ACLnode;
  n->set(key,a,NULL);

  if(a == NULL){
    n->set_right(b);
    if(b != NULL)
      b->set_right(c);
  }
  else{
    if(b != NULL){
      a->set_right(b);
      b->set_right(c);
    }
    else
      a->set_right(c);
  }

  return n;
}
  
ACLnode * m_aobject(ACLnode *a)
{
  if(a == NULL)
    return NULL;

  ACLnode *n = new ACLnode;
  n->set(Parser::OBJECT,a,NULL);
  return n;
}

ACLnode * m_source(ACLnode *a)
{
  if(a == NULL)
    return NULL;

  ACLnode *n = new ACLnode;
  n->set(Parser::SOURCE,a,NULL);
  return n;
}

ACLnode * m_goal(ACLnode *a)
{
  if(a == NULL)
    return NULL;

  ACLnode *n = new ACLnode;
  n->set(Parser::GOAL,a,NULL);
  return n;
}

ACLnode * m_place(ACLnode *a)
{
  if(a == NULL)
    return NULL;

  ACLnode *n = new ACLnode;
  n->set(Parser::PLACE,a,NULL);
  return n;
}

ACLnode * m_position(int x,int y)
{
  ACLnode *a = new ACLnode;
  a->set(Parser::INTEGER,NULL,NULL);
  a->set_value(x);

  ACLnode *b = new ACLnode;
  b->set(Parser::INTEGER,NULL,NULL);
  b->set_value(y);

  ACLnode *n = new ACLnode;
  n->set(Parser::POSITION,a,NULL);

  a->set_right(b);

  return n;
}

ACLnode * m_time(int time)
{
  ACLnode *a = new ACLnode;
  a->set(Parser::INTEGER,NULL,NULL);
  a->set_value(time);

  ACLnode *n = new ACLnode;
  n->set(Parser::TIME,a,NULL);

  return n;
}

ACLnode * m_degree(int degree)
{
  ACLnode *a = new ACLnode;
  a->set(Parser::INTEGER,NULL,NULL);
  a->set_value(degree);

  ACLnode *n = new ACLnode;
  n->set(Parser::DEGREE,a,NULL);

  return n;
}

ACLnode * m_agent(int id)
{
  ACLnode *a = new ACLnode;
  a->set(Parser::INTEGER,NULL,NULL);
  a->set_value(id);

  ACLnode *n = new ACLnode;
  n->set(Parser::AGENT,a,NULL);
  return n;
}

ACLnode * m_tagent(int id)
{
  ACLnode *a = new ACLnode;
  a->set(Parser::TINTEGER,NULL,NULL);
  a->set_value(id);

  ACLnode *n = new ACLnode;
  n->set(Parser::AGENT,a,NULL);
  return n;
}

ACLnode * m_object_a(int key,int id)
{
  ACLnode *a = new ACLnode;
  a->set(Parser::INTEGER,NULL,NULL);
  a->set_value(id);

  ACLnode *n = new ACLnode;
  n->set(key,a,NULL);

  return n;
}

ACLnode * m_tobject_a(int key,int id)
{
  ACLnode *a = new ACLnode;
  a->set(Parser::TINTEGER,NULL,NULL);
  a->set_value(id);

  ACLnode *n = new ACLnode;
  n->set(key,a,NULL);

  return n;
}
ACLnode * m_object_b(int key,int id1,int id2)
{
  ACLnode *a = new ACLnode;
  a->set(Parser::INTEGER,NULL,NULL);
  a->set_value(id1);

  ACLnode *b = new ACLnode;
  b->set(Parser::INTEGER,NULL,NULL);
  b->set_value(id2);

  ACLnode *n = new ACLnode;
  n->set(key,a,NULL);

  a->set_right(b);
  return n;
}

ACLnode * m_set()
{
  ACLnode *n = new ACLnode; 
  n->set(Parser::SET,NULL,NULL);
  return n;
}

void m_set_insert(ACLnode *a,ACLnode *b)
{
  ACLnode *t;
  t = a->left();

  if(t == NULL)
    a->set_left(b);   
  else{
    while(t->right() != NULL)
      t = t->right();    
    t->set_right(b);
  }
}

///////////////////////////////////////////////////////////

char * change(ACLnode *n)
{
  static char buff[10];

  switch(n->key()){
  case Parser::INTEGER:
    sprintf(buff,"%d",n->value());
    return buff;

  case Parser::TINTEGER:
    sprintf(buff,"T%d",n->value());
    return buff;

  case Parser::SET:
    return "set"; break;

  case Parser::INFORM:
    return "inform"; break;

  case Parser::QUERYIF:
    return "queryif"; break;

  case Parser::REQUEST:
    return "request"; break;

  case Parser::CANCEL:
    return "cancel"; break;

  case Parser::NOTUNDERSTOOD:
    return "not-understood"; break;

  case Parser::STATE:
    return "state"; break;

  case Parser::TYPE:
    return "type"; break;

  case Parser::ACTION:
    return "action"; break;

  case Parser::AGENT:
    return "agent"; break;

  case Parser::T:
    return "T"; break;

  case Parser::TRUE:
    return "true"; break;

  case Parser::FALSE:
    return "false"; break;

  case Parser::SOURCE:
    return "source"; break;

  case Parser::GOAL:
    return "goal"; break;

  case Parser::PLACE:
    return "place"; break;

  case Parser::TIME:
    return "time"; break;

  case Parser::OBJECT:
    return "object"; break;

  case Parser::POSITION:
    return "position"; break;

  case Parser::DEGREE:
    return "degree"; break;

  case Parser::DONE:
    return "done"; break;

  case Parser::BE:
    return "be"; break;

  case Parser::BURIED:
    return "buried"; break;

  case Parser::DAMEGE:
    return "damege"; break;

  case Parser::BLOCKED:
    return "blocked"; break;

  case Parser::FIRE:
    return "fire"; break;

  case Parser::BROKEN:
    return "brokem"; break;

  case Parser::MOVE:
    return "move"; break;

  case Parser::SAY:
    return "say"; break;

  case Parser::TELL:
    return "tell"; break;

  case Parser::RESCUE:
    return "rescue"; break;

  case Parser::OPEN:
    return "open"; break;

  case Parser::EXTINGUISH:
    return "extinguish"; break;

  case Parser::CARRY:
    return "carry"; break;

  case Parser::HELP:
    return "help"; break;

  case Parser::BUILDING:
    return "building"; break;

  case Parser::RIVER:
    return "river"; break;

  case Parser::ROAD:
    return "road"; break;

  case Parser::CIVILIAN:
    return "Civilian"; break;

  case Parser::CAR:
    return "Car"; break;

  case Parser::FIREBRIGADE:
    return "FireBrigade"; break;

  case Parser::AMBULANCETERM:
    return "AmbulanceTeam"; break;

  case Parser::POLICEOFFICE:
    return "PoliceOffice"; break;

  case Parser::REFUGE:
    return "Refuge"; break;
  }
  return NULL;
}



 
