#include "ACLtree.hxx"
#include <stdlib.h>
#include <string.h>
#include <vector>
#include "ACLsub.hxx"

ACLnode::ACLnode()
{
  _key = 0;
  _value = 0;
  _left = NULL;
  _right = NULL;
}

ACLtree::ACLtree()
{
  _root = NULL;
}

void ACLtree::find_sub(vector<ACLnode *> *l,ACLnode *n,int k)
{
  if(n->key() == k)
    l->push_back(n);

  if(n->left() != NULL)
    find_sub(l,n->left(),k);
  if(n->right() != NULL)
    find_sub(l,n->right(),k);
}

ACLnode ** ACLtree::find(ACLnode *n,int k)
{
  vector<ACLnode*> l;
  find_sub(&l,n,k);

  ACLnode **list = new ACLnode * [l.size()+1];
  int i=0;

  while((int)l.size() > i){
    list[i] = l[i];
    i++;
  }

  list[i] = NULL;

  return list;
}



void ACLtree::print_tree_sub(int i,ACLnode *n)
{
  int j;
  char *buff = new char[10];

  *buff = '\0';
  if(n->right() != NULL)
    for(j = strlen(change(n));j<=10;j++)
      strcat(buff,"-");
 
  printf("%s%s",change(n),buff);
  if(n->right() != NULL){
    print_tree_sub(i+1,n->right());
  }
  else
    printf("\n");

  if(n->left() != NULL){
    for(j=0;j<i;j++)
      printf("  |        ");
    print_tree_sub(i,n->left());
  }
}

void ACLtree::print_tree()
{
    print_tree_sub(0,_root);
    printf("\n");
}

