#ifndef _ACLTREE
#define _ACLTREE

#include "parser.h"
#include <vector>

class ACLnode{
private:
  int _key;
  int _value;
  ACLnode *_right;
  ACLnode *_left;
public:
  ACLnode();

  void set(int k,ACLnode *l,ACLnode *r)
  {_key = k;_left = l;_right  = r;}

  void set_key(int k){_key = k;}
  void set_right(ACLnode *r){_right = r;}
  void set_left(ACLnode *l){_left = l;}
  void set_value(int v){_value = v;}

  int key(){return _key;}
  int value(){return _value;}
  ACLnode * right(){return _right;}
  ACLnode * left(){return _left;}
};

class ACLtree{
protected:
  ACLnode *_root;
public:
  ACLtree();
  void set_root(ACLnode *n){_root = n;}
  ACLnode * root(){return _root;}

  void find_sub(vector<ACLnode *> *l,ACLnode *n,int k);
  ACLnode ** find(ACLnode *n,int k);

  void print_tree_sub(int i,ACLnode *n);
  void print_tree();

};

#endif
