#! /bin/sh

if [ $# -ne 2 ]; then
    echo "usage: game.sh <team name> <map file>"
    exit 0
fi
if [ ! -f "$2" ]; then
    echo "error: $2 should be a map file name."
    exit 0
fi

teamname=$1
mapfile=$2

time=`date +%m%d-%H%M%S`
basename=/export/home/results/${time}-`hostname`-$teamname-${mapfile##*/}
logname=${basename}.log
mapname=${basename}.gisini.txt

cp -f "$mapfile" ./gisini.txt
chmod a+wr ./gisini.txt
if [ -e $logname ]; then
echo "error: $logname exits"
    exit 0
fi
if [ -e $mapname ]; then
    echo "error: $mapname exits"
    exit 0
fi
touch $logname
cp $mapfile $mapname

echo "log file: $logname"
echo "map file backup: $mapname"

xterm -e ./0gis.sh &
sleep 5
xterm -e ./1kernel.sh -logname $lognamei &
sleep 5
#xterm -e ./3miscsimulator.sh &
xterm -e ./trafficsimulator.sh &
#xterm -e ./firesimulator.sh &
#xterm -e ./6blockadessimulator.sh &
#xterm -e ./7collapsesimulator.sh &
xterm -e ./2viewer.sh &
#sleep 5
#xterm -e ../Civilian0.1/Civilian2/Civilian2.sh &
#xterm -e ../Civilian0.1/Civilian1/Civilian1.sh &
#xterm -e ../Civilian0.1/Civilian3/Civilian3.sh &
#xterm -e ./8samplecivilian.sh &
