// simworld_auxmove.cxx ...  νؿ

#include "common.hxx"
#include "basic.hxx"
#include "Config.hxx"
#include "Address.hxx"
#include "Input.hxx"
#include "Output.hxx"
#include "LongUDPSocket.hxx"
#include "ObjectPool.hxx"
#include "objects.hxx"
#include "sim_class.h"
using namespace Rescue;

extern std::ofstream ferrout;

#define ONCOMING_CAR_DISTANCE 16

// ΰưˡ֤ؿ
int RealMap::getAccess(Id now_id,Id next_id)
// this returns 0(right), 1(left), 2(straight), -1  &  100
{
  int con1,con2,p=UNDEFINED;
  SimRoads::iterator now = sim_road.find(now_id);
  SimRoads::iterator next = sim_road.find(next_id);
  SimNodes::iterator node_id;

  // 01ľ2
  if(now->first==next->first){
    p = STRAIGHT;
  }else if(now->second.head==next->second.head){
    node_id = sim_node.find(now->second.head);
    con1 = now->second.head_connect_num;
    con2 = next->second.head_connect_num;
  }else if(now->second.head==next->second.tail){
    node_id = sim_node.find(now->second.head);
    con1 = now->second.head_connect_num;
    con2 = next->second.tail_connect_num;
  }else if(now->second.tail==next->second.head){
    node_id = sim_node.find(now->second.tail);
    con1 = now->second.tail_connect_num;
    con2 = next->second.head_connect_num;
  }else if(now->second.tail==next->second.tail){
    node_id = sim_node.find(now->second.tail);
    con1 = now->second.tail_connect_num;
    con2 = next->second.tail_connect_num;
  }else{
    // ʤ԰
    p = ILLEGAL;
  }
  if(p==UNDEFINED) p = node_id->second.accessKind[con1][con2]; // 0, 1, 2, -1
  return p;		// 0, 1, 2, -1, 100
}

///////////////////////////////////////////////////////////////////////////////
// и֤ONCOMINGCAR_DISTˤ뤫(cf.16m/s®)
int RealMap::judgeOncomingCar(Id k)
{
  int i,con1,con2,flag=0,p=0;
  SimCars::iterator move,loop_car;
  SimRoads::iterator now,loop_road,ag_road;
  SimNodes::iterator node_id;

  move = sim_car.find(k);
  now = sim_road.find(move->second.position);
  node_id = sim_node.find(move->second.aim[move->second.step+1]);
  if(move->second.direct==HEAD)    con1 = now->second.head_connect_num;
  else                          con1 = now->second.tail_connect_num;
  for(i=0;i<node_id->second.connect_road_num;i++){
    if(node_id->second.accessKind[con1][i] == STRAIGHT){
      con2 =i;
      flag = 1;
      break;
    }
  }
  // ľʤȤflag=1

  if(flag==1){
    for(loop_road = sim_road.begin();loop_road!=sim_road.end();loop_road++){
      if(loop_road->second.head==node_id->first && 
	 loop_road->second.head_connect_num==con2){
	ag_road = loop_road;
	break;
      }else if(loop_road->second.tail==node_id->first && 
	       loop_road->second.tail_connect_num==con2){
	ag_road = loop_road;
	break;
      }
    }

    if(ag_road->second.head == node_id->first){
      loop_car = sim_car.begin();
      while(loop_car!=sim_car.end()){
		  if((loop_car->second).isPedestrian()) { // only car
			  loop_car++; continue;
		}
		if(loop_car->second.motion==1 && 
			loop_car->second.position==ag_road->first && 
			(loop_car->second.positionExtra<=ONCOMING_CAR_DISTANCE*1000) && 
			(loop_car->second.direct==HEAD)){
			// и֤ľʤݤ(000720)
			if(loop_car->second.aim_num > loop_car->second.step+2) {
				SimNodes::iterator cnode=sim_node.find(loop_car->second.aim[loop_car->second.step+2]);
				int ca = getAccess(loop_car->second.position, cnode->first);
				if(ca == STRAIGHT) p = 1;
				else p = 0;
			}
			else p = 0;
			break;
		}
		loop_car++;
      }
    }else if(ag_road->second.tail == node_id->first){
      loop_car = sim_car.begin();
      while(loop_car!=sim_car.end()){
		  if((loop_car->second).isPedestrian()) { // only car 
			  loop_car++; continue;
		}
		if(loop_car->second.motion==1 && 
			loop_car->second.position==ag_road->first && 
			(ag_road->second.pointer->length()-
			loop_car->second.positionExtra<=ONCOMING_CAR_DISTANCE*1000) &&
			(loop_car->second.direct==TAIL)){
			// и֤ľʤݤ(000720)
			if(loop_car->second.aim_num > loop_car->second.step+2) {
				SimNodes::iterator cnode=sim_node.find(loop_car->second.aim[loop_car->second.step+2]);
				int ca = getAccess(loop_car->second.position, cnode->first);
				if(ca == STRAIGHT) p = 1;
				else p = 0;
			}
			else p = 0;
			break;
		}
		loop_car++;
      }
    }
  }
  else  {
	  p = 0;
  }
  return p;
}

///////////////////////////////////////////////////////////////////////////////
// ͽΥɤƤ
int RealMap::getAliveLines(Id k,Id now_id,Id next_id)
{
  int p;
  SimCars::iterator move = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(now_id);
  SimRoads::iterator next = sim_road.find(next_id);
  if(move->second.aim[move->second.step+1]==next->second.head){
    p = next->second.linesAliveTail;
  }else{
    p = next->second.linesAliveHead;
  }
  return p;
}

///////////////////////////////////////////////////////////////////////////////
// ;Ϥ뤫ɤ
int RealMap::judgeInroad(Id k)
{	
  int i,dire,alive,lines,access,p=0;
  SimCars::iterator move,last;
  SimRoads::iterator now,next;
  move = sim_car.find(k);
  now = sim_road.find(move->second.position);
  next = sim_road.find(move->second.aim[move->second.step+2]);
		/*----------------------------------------------------*
		 * δؿƤФ硤aimĹ>move->second.step+2  *
		 *----------------------------------------------------*/
  if(move->second.aim[move->second.step+1]==next->second.head){
    lines = (next->second.pointer)->linesToTail();
    dire = TAIL;
  }else{
    lines = (next->second.pointer)->linesToHead();
    dire = HEAD;
  }
  alive = getAliveLines(move->first,now->first,next->first);
  // μζʤ
  if(move->second.aim_num > move->second.step+4){
	Id id4 = move->second.aim[move->second.step+4];
	if(sim_road.find(id4) != sim_road.end())
		access = getAccess(next->first,id4);
	else access = UNDEFINED;
  }else{
    access = UNDEFINED;
  }
  if(access!=RIGHT && access!=LEFT && access!=STRAIGHT && access!=UNDEFINED) {
	printf("Warning: route plan is invalid.\n");
	ferrout << "Warning in JudgeInroad: invalid route plan for the car " 
		    << move->first << "\n" << std::flush;
	access = UNDEFINED; // 
//	exit(1);
	// This case will not happen.
  }
  if(alive > 0) {
	if(access==RIGHT){
		if(dire==HEAD && next->second.head_last_id[lines-1]!=NP){
			last = sim_car.find(next->second.head_last_id[lines-1]);
			if(next->second.pointer->length()-last->second.positionExtra >= DIST_BET_CARS*1000) p=1;
		} else if(dire==TAIL && next->second.tail_last_id[lines-1]!=NP){
			last = sim_car.find(next->second.tail_last_id[lines-1]);
			if(last->second.positionExtra >= DIST_BET_CARS*1000) p = 1;
		} else{
			p = 1;
		}
	} else if(access==LEFT){
		if(dire==HEAD && next->second.head_last_id[lines-alive]!=NP){
			last = sim_car.find(next->second.head_last_id[lines-alive]);
			if(next->second.pointer->length()-last->second.positionExtra >= DIST_BET_CARS*1000) p=1;
		}else if(dire==TAIL && next->second.tail_last_id[lines-alive]!=NP){
			last = sim_car.find(next->second.tail_last_id[lines-alive]);
			if(last->second.positionExtra >= DIST_BET_CARS*1000) p=1;
		}else{
			p =1;
		}
	} else{ // STRAIGHT | UNDEFINED
		for(i=0; i<alive; i++) {
			if(dire == HEAD) {
				if(next->second.head_last_id[lines-1-i]==NP) { p = 1; break; }
				else {
					last = sim_car.find(next->second.head_last_id[lines-1-i]);
					if(next->second.pointer->length()-last->second.positionExtra>=DIST_BET_CARS*1000){
						p = 1;
						break;
					}
				}
			} else if(dire == TAIL) {
				if(next->second.tail_last_id[lines-1-i]==NP) { p = 1; break; }
				else {
					last = sim_car.find(next->second.tail_last_id[lines-1-i]);
					if(last->second.positionExtra >= DIST_BET_CARS*1000) {
						p = 1;
						break;
					}
				}
			}
		}
	}
  } else p = 0; // alive == 0
  return p;
}

///////////////////////////////////////////////////////////////////////////////
// ٤ֹȼοʹ԰տ(RIGHT,LEFT,STRAIGHT)ؿ
int *RealMap::getLineInroad(Id k)
{
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
		/*----------------------------------------------------*
		 * δؿƤФ硤aimĹ>move->second.step+2  *
		 *----------------------------------------------------*/
  int access, x=0, lines, alive;
  // μζʤ
  if(p->second.aim_num > p->second.step+4){
	Id id4 = p->second.aim[p->second.step+4];
	if(sim_road.find(id4) != sim_road.end())
		access = getAccess(next->first,id4);
	else access = UNDEFINED;
  }else{
    access = UNDEFINED;
  }
  if(access!=RIGHT && access!=LEFT && access!=STRAIGHT && access!=UNDEFINED) {
	printf("Error in getLineInRoad: route plan is invalid .");
	ferrout << "Warning in getLineInroad: invalid route plan for the car " << "\n" << std::flush;
//	exit(1);
	// This case do not happen, because this is already checked in judgeInRoad().
  }

  if(p->second.aim[p->second.step+1]==next->second.tail){
    lines = next->second.pointer->linesToHead();
    alive = next->second.linesAliveHead; // alive > 0Ǥ
    if(access==RIGHT){
      x = lines - 1;
    }else if(access==LEFT){
      x = lines - alive;
    }else{ // STRAIGHT | UNDEFINED
      /* ǸֿʤǤ
	  int i, j=0;
      SimCars::iterator last;	
      SimCars::iterator tmp;
      for(i=(lines-alive);i<lines;i++){
		if(next->second.head_last_id[i]==NP){
			j = i;
			break;
		}else {
			if(i==(lines-alive)){
				j = lines - alive;
				last = sim_car.find(next->second.head_last_id[j]);
			}else{
				tmp = sim_car.find(next->second.head_last_id[i]);
				if(last->second.positionExtra>=tmp->second.positionExtra){
					j = i;
					last = sim_car.find(next->second.head_last_id[j]);
				}
			}	
		}
      }
      x = j;
	  */
	  x = (lines-alive)+(int)(p->first%alive);
    }
  } else if(p->second.aim[p->second.step+1]==next->second.head) {
    lines = next->second.pointer->linesToTail();
    alive = next->second.linesAliveTail; // alive > 0 Ǥ
    if(access==RIGHT){
      x = lines - 1;
    }else if(access==LEFT){
      x = lines - alive;
    }else{ // STRAIGHT | UNDEFINED
      /* ǸֿʤǤ
      SimCars::iterator last;
      SimCars::iterator tmp;
      for(i=(lines-alive);i<lines;i++){
		if(next->second.tail_last_id[i]==NP){
			j = i;
			break;
		}else {
			if(i==(lines-alive)){
				j = lines - alive;
				last = sim_car.find(next->second.tail_last_id[j]);
			}else{
				tmp = sim_car.find(next->second.tail_last_id[i]);
				if(tmp->second.positionExtra>=last->second.positionExtra){
					j = i;
					last = sim_car.find(next->second.tail_last_id[j]);
				}
			}		
		}
      }
      x = j;
	  */
	  x = (lines-alive)+(int)(p->first%alive);
    }
  }
  if(access == UNDEFINED) access = STRAIGHT; // assumption
  int go[2]; go[0] = x; go[1] = access;
  return go;
}

////////////////////////////////////////////////////////////////////////////
// ;Ϥ뤫ɤ(PEDESTRIAN)
int RealMap::pjudgeInroad(Id k)
{
  int dire,alive,access,p=0;
  SimCars::iterator move,last;
  SimRoads::iterator now,next;
  move = sim_car.find(k);
  now = sim_road.find(move->second.position);
  next = sim_road.find(move->second.aim[move->second.step+2]);
		/*----------------------------------------------------*
		 * δؿƤФ硤aimĹ>move->second.step+2  *
		 *----------------------------------------------------*/
  if(move->second.aim[move->second.step+1]==next->second.head){
    dire = TAIL;
  }else{
    dire = HEAD;
  }
  alive = getAliveLines(move->first,now->first,next->first);
  // μζʤ
  if(move->second.aim_num > move->second.step+4){
	Id id4 = move->second.aim[move->second.step+4];
	if(sim_road.find(id4) != sim_road.end())
		access = getAccess(next->first,id4);
	else access = UNDEFINED;
  }else{
    access = UNDEFINED;
  }
  if(access!=RIGHT && access!=LEFT && access!=STRAIGHT && access!=UNDEFINED) {
	printf("Warning: route plan is invalid.\n");
	ferrout << "Warning in pjudgeInroad: invalid route plan for the car " << move->first << "\n" << std::flush;
	access = UNDEFINED; // 
//	exit(1);
	// This case will not happen.
  }

  if(alive > 0) {	// MAX_NUM_OF_PLINESϣ
	if(access==RIGHT){
		if(dire==HEAD && next->second.phead_last_id[0]!=NP){
			last = sim_car.find(next->second.phead_last_id[0]);
			if(next->second.pointer->length()-last->second.positionExtra >= DIST_BET_PEDESTRIANS*1000) p=1;
		} else if(dire==TAIL && next->second.ptail_last_id[0]!=NP){
			last = sim_car.find(next->second.ptail_last_id[0]);
			if(last->second.positionExtra >= DIST_BET_PEDESTRIANS*1000) p = 1;
		} else{
			p = 1;
		}
	} else if(access==LEFT){
		if(dire==HEAD && next->second.phead_last_id[0]!=NP){
			last = sim_car.find(next->second.phead_last_id[0]);
			if(next->second.pointer->length()-last->second.positionExtra >= DIST_BET_PEDESTRIANS*1000) p=1;
		}else if(dire==TAIL && next->second.ptail_last_id[0]!=NP){
			last = sim_car.find(next->second.ptail_last_id[0]);
			if(last->second.positionExtra >= DIST_BET_PEDESTRIANS*1000) p=1;
		}else{
			p =1;
		}
	} else{ // STRAIGHT | UNDEFINED
			if(dire == HEAD) {
				if(next->second.phead_last_id[0]==NP) { p = 1; }
				else {
					last = sim_car.find(next->second.phead_last_id[0]);
					if(next->second.pointer->length()-last->second.positionExtra>=DIST_BET_PEDESTRIANS*1000){
						p = 1;
					}
				}
			} else if(dire == TAIL) {
				if(next->second.ptail_last_id[0]==NP) { p = 1; }
				else {
					last = sim_car.find(next->second.ptail_last_id[0]);
					if(last->second.positionExtra >= DIST_BET_PEDESTRIANS*1000) {
						p = 1;
					}
				}
			}
	}
  } else p = 0; // alive == 0
  return p;
}

///////////////////////////////////////////////////////////////////////////////
// ٤ֹȼοʹ԰տ(RIGHT,LEFT,STRAIGHT)ؿ(PEDESTRIAN)
int *RealMap::pgetLineInroad(Id k)
{
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
		/*----------------------------------------------------*
		 * δؿƤФ硤aimĹ>move->second.step+2  *
		 *----------------------------------------------------*/
  int i, access, x=0;
  // μζʤ
  if(p->second.aim_num > p->second.step+4){
	Id id4 = p->second.aim[p->second.step+4];
	if(sim_road.find(id4) != sim_road.end())
		access = getAccess(next->first,id4);
	else access = UNDEFINED;
  }else{
    access = UNDEFINED;
  }
  if(access!=RIGHT && access!=LEFT && access!=STRAIGHT && access!=UNDEFINED) {
	printf("ERROR in getLineInRoad: route plan is invalid.");
	ferrout << "Warning in pgetLineInroad: invalid route plan for the car " << "\n" << std::flush;
//	exit(1);
	// This case do not happen, because this is already checked in judgeInRoad().
  }

  if(p->second.aim[p->second.step+1]==next->second.tail){
    if(access==RIGHT){
      x = 0;
    }else if(access==LEFT){
      x = 0;
    }else{ // STRAIGHT | UNDEFINED
	  x = 0;
    }
  } else if(p->second.aim[p->second.step+1]==next->second.head) {
    if(access==RIGHT){
      x = 0;
    }else if(access==LEFT){
      x = 0;
    }else{ // STRAIGHT | UNDEFINED
	  x = 0;
    }
  }
  if(access == UNDEFINED) access = STRAIGHT; // assumption
  int go[2]; go[0] = x; go[1] = access;
  return go;
}

///////////////////////////////////////////////////////////////////////////////
