// simworld_carmove.cxx ... carmoveؿ

#include <stdio.h>
#include <stdlib.h>

#include "common.hxx"
#include "basic.hxx"
#include "Config.hxx"
#include "Address.hxx"
#include "Input.hxx"
#include "Output.hxx"
#include "LongUDPSocket.hxx"
#include "ObjectPool.hxx"
#include "objects.hxx"
#include "sim_class.h"
using namespace Rescue;

extern std::ofstream ferrout;

// moveؿ
void RealMap::move(Id move_id)
{
  // ޥݥåȰư(move_to_pocket),ư(move_normal),ʪư(move_to_building)
  // ؤʬؿ
  SimCars::iterator p = sim_car.find(move_id);
  SimRoads::iterator now = sim_road.find(p->second.position);

  if((p->second.aim_num == p->second.step+2) || 
	 (p->second.aim_num == p->second.step+1)) { // MA(00/06/08)
		move_normal(p->first);
  } else {
		SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);

		// MA: aim[p->second.step+2] can be building and 
		// all procesing for building may be written here...ӥǥ󥰤ؤΰư
		if(next == sim_road.end()) {
#ifdef DEBUG
			printf("#Building=%d#", p->second.aim[p->second.step+2]);
#endif
			move_toward_building(p->first, p->second.aim[p->second.step+2]);
			p->second.flag += 1;
			return;
		}
		// END

		int access = getAccess(now->first,next->first);
		if(access == ILLEGAL || access == UNDEFINED) {
			printf("Warning: route plan is invalid.\n");
			ferrout << "Warning in move: invalid route plan for the car " 
				    << p->first << " at " << now->first << "->" << next->first << "\n" << std::flush;
			access = STRAIGHT; // 
			return; // 00/12/28
		//	exit(1);
		}

		SimNodes::iterator node_id;
		int con1;
		if(p->second.direct==HEAD){
			node_id = sim_node.find(now->second.head);
			con1 = now->second.head_connect_num;
		}else if(p->second.direct==TAIL){
			node_id = sim_node.find(now->second.tail);
			con1 = now->second.tail_connect_num;
		}
		if((access==RIGHT)&&									// ްտ
		   (node_id->second.pocketToTurnAcross.size()>0)&&		// ޥݥåȤ
		   (node_id->second.pocketToTurnAcross[2*(con1)]>0)&&
		   (p->second.pocket==0)) {								// ݥåȤˤʤ
			if(p->second.direct==HEAD && p->second.speed>=(MAX_SPEED-ACCELERATION)*1000 &&
			   (p->second.positionExtra-MAX_SPEED*1000)>
			    node_id->second.pocketToTurnAcross[2*(con1)+1]) {
					move_normal(p->first);
			} else if(p->second.direct==HEAD && 
				      (p->second.positionExtra-(p->second.speed+ACCELERATION*1000))>
					   node_id->second.pocketToTurnAcross[2*(con1)+1]) {
				move_normal(p->first);
			} else if(p->second.direct==TAIL && p->second.speed >= (MAX_SPEED-ACCELERATION)*1000 &&
					  (now->second.pointer->length()-(p->second.positionExtra+MAX_SPEED*1000))>
					   node_id->second.pocketToTurnAcross[2*(con1)+1]) {
				move_normal(p->first);
			} else if(p->second.direct==TAIL && 
				      (now->second.pointer->length()-
					   (p->second.positionExtra+p->second.speed+ACCELERATION*1000))>
						node_id->second.pocketToTurnAcross[2*(con1)+1]) {
				move_normal(p->first);
			} else {
				if(p->second.front_id!=NP) {
					SimCars::iterator front = sim_car.find(p->second.front_id);
					if(p->second.direct==HEAD && 
					   (front->second.positionExtra+DIST_BET_CARS*1000)>
						node_id->second.pocketToTurnAcross[2*(con1)+1]) {
						move_normal(p->first);
					}else if(p->second.direct==TAIL && 
						     (now->second.pointer->length()-
							  front->second.positionExtra+DIST_BET_CARS*1000)>
							 node_id->second.pocketToTurnAcross[2*(con1)+1]) {
						move_normal(p->first);
					}else{
						move_to_pocket(p->first);
					}
				} else {
					move_to_pocket(p->first);
				}
			}
		} else {
			move_normal(p->first);
		}
  }
  p->second.flag += 1;
}

//////////////////////////////////////////////////////////////////////////////
// ޥݥåȤؤδؿ
void RealMap::move_to_pocket(Id k)
{
  // ޥݥåȤ;ϤХݥåȤ(move_in_pocket)
  // ʤбޥݥåȤμԵ
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  int con;
  if(p->second.direct==HEAD && now->second.head_pocket==NP) { // إåɥݥåȤ˼֤ʤ
    move_in_pocket(p->first);
  } else if(p->second.direct==TAIL && now->second.tail_pocket==NP) { // ơݥåȤ˼֤ʤ
    move_in_pocket(p->first);
  } else {
	  if(p->second.direct==HEAD){ // إåɥݥåȤ˼֤
      SimCars::iterator last = sim_car.find(now->second.head_pocket);
      SimNodes::iterator node_id = sim_node.find(now->second.head);
      con = now->second.head_connect_num;
      if(last->second.positionExtra+DIST_BET_CARS*1000 <
	 node_id->second.pocketToTurnAcross[2*(con)+1]){
	move_in_pocket(p->first);
      }else{
	// ˤȤޤ
	p->second.speed = p->second.positionExtra - 
	  node_id->second.pocketToTurnAcross[2*(con)+1];
	p->second.positionExtra -= p->second.speed;
	if(p->second.positionExtra<0){
	  printf("positionExtra error in move_to_pocket\n");
	  exit(1);
	}
	p->second.between -= p->second.speed;
	if(p->second.back_id!=NP){
	  SimCars::iterator back = sim_car.find(p->second.back_id);
	  back->second.between += p->second.speed;
	}
      }
	  }else{ // ơݥåȤ˼֤
      SimCars::iterator last = sim_car.find(now->second.tail_pocket);
      SimNodes::iterator node_id = sim_node.find(now->second.tail);
      con = now->second.tail_connect_num;
      if(now->second.pointer->length()-last->second.positionExtra+DIST_BET_CARS*1000 <
	 node_id->second.pocketToTurnAcross[2*(con)+1]){
	move_in_pocket(p->first);
      }else{
	// ˤȤޤ
	p->second.speed = now->second.pointer->length() - 
	  p->second.positionExtra - node_id->second.pocketToTurnAcross[2*(con)+1];
	p->second.positionExtra += p->second.speed;
	if(p->second.positionExtra<0){
	  printf("positionExtra error in move_to_pocket\n");
	  exit(1);
	}
	p->second.between -= p->second.speed;
	if(p->second.back_id!=NP){
	  SimCars::iterator back = sim_car.find(p->second.back_id);
	  back->second.between += p->second.speed;
	}
      }
    }
  }
}

///////////////////////////////////////////////////////////////////////////////
// ݥåȤؤοؿ
void RealMap::move_in_pocket(Id k)
{
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  // ǡ(front_id, back_id, between, head_last_id, tail_last_id)
  if(p->second.front_id!=NP && p->second.back_id!=NP){ // ˼
    SimCars::iterator front = sim_car.find(p->second.front_id);
    SimCars::iterator back = sim_car.find(p->second.back_id);
    front->second.back_id = back->first;
    back->second.front_id = front->first;
    back->second.between = labs(back->second.positionExtra - front->second.positionExtra);
  }else if(p->second.front_id!=NP){ // Τ߼
    SimCars::iterator front = sim_car.find(p->second.front_id);
    if(p->second.direct==HEAD) now->second.head_last_id[p->second.line] = front->first;
    else now->second.tail_last_id[p->second.line] = front->first;
    front->second.back_id = NP;
  }else if(p->second.back_id!=NP){ // Τ߼
    SimCars::iterator back = sim_car.find(p->second.back_id);
    back->second.front_id = NP;
    if(p->second.direct==HEAD) back->second.between = back->second.positionExtra;
    else back->second.between = now->second.pointer->length() - back->second.positionExtra;
  }else{ // ֤ʤ
    if(p->second.direct==HEAD) now->second.head_last_id[p->second.line] = NP;
    else                    now->second.tail_last_id[p->second.line] = NP;
  }
  // ݥåȤ
  p->second.back_id = NP;
  p->second.pocket = 1;
  if(p->second.direct==HEAD && now->second.head_pocket==NP){
    if(p->second.speed >= (MAX_SPEED-ACCELERATION)*1000 && 
		p->second.positionExtra>=MAX_SPEED*1000){
      p->second.speed = MAX_SPEED*1000;
    }else if(p->second.positionExtra>=p->second.speed+ACCELERATION*1000){
      p->second.speed += ACCELERATION*1000;
    }else{
      p->second.speed = p->second.positionExtra;
    }
    p->second.positionExtra -= p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in move_in_pocket\n");
      exit(1);
    }
    p->second.between = p->second.positionExtra;
    p->second.front_id = NP;
    now->second.head_pocket = p->first;
  }else if(p->second.direct==TAIL && now->second.tail_pocket==NP){
    if(p->second.speed >= (MAX_SPEED-ACCELERATION)*1000 && 
		now->second.pointer->length() - p->second.positionExtra>=MAX_SPEED*1000){
      p->second.speed = MAX_SPEED*1000;
    }else if(now->second.pointer->length() - p->second.positionExtra >=
	     p->second.speed+ACCELERATION*1000){
      p->second.speed += ACCELERATION*1000;
    }else{
      p->second.speed = now->second.pointer->length()-p->second.positionExtra;
    }
    p->second.positionExtra += p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in move_in_pocket\n");
      exit(1);
    }
    p->second.between = now->second.pointer->length()-p->second.positionExtra;
    p->second.front_id = NP;
	now->second.tail_pocket = p->first;
  }else{
    if(p->second.direct==HEAD){
      SimCars::iterator last = sim_car.find(now->second.head_pocket);
      if(p->second.speed>=(MAX_SPEED-ACCELERATION)*1000 && 
	     p->second.positionExtra-last->second.positionExtra-DIST_BET_CARS*1000>=MAX_SPEED*1000){
		p->second.speed = MAX_SPEED*1000;
      }else if(p->second.positionExtra-last->second.positionExtra-DIST_BET_CARS*1000>=
	           p->second.speed+ACCELERATION*1000){
		p->second.speed += ACCELERATION*1000;
      }else{
		p->second.speed = p->second.positionExtra - 
		last->second.positionExtra-DIST_BET_CARS*1000;
      }
      p->second.positionExtra -= p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_in_pocket\n");
		exit(1);
      }
      p->second.between = p->second.positionExtra-last->second.positionExtra;
      p->second.front_id = last->first;
	  last->second.back_id = p->first;
      now->second.head_pocket = p->first;
    } else { 
      SimCars::iterator last = sim_car.find(now->second.tail_pocket);
      if(p->second.speed>=(MAX_SPEED-ACCELERATION)*1000 && 
	     last->second.positionExtra-p->second.positionExtra-DIST_BET_CARS*1000>=MAX_SPEED*1000){
		p->second.speed = MAX_SPEED*1000;
      } else if(last->second.positionExtra-p->second.positionExtra-DIST_BET_CARS*1000>=
	            p->second.speed+ACCELERATION*1000){
		p->second.speed += ACCELERATION*1000;
      }else{
		p->second.speed = last->second.positionExtra - 
	                       p->second.positionExtra-DIST_BET_CARS*1000;
      }
      p->second.positionExtra += p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_in_pocket\n");
		exit(1);
      }
      p->second.between = last->second.positionExtra-p->second.positionExtra;
      p->second.front_id = last->first;
	  last->second.back_id = p->first;
      now->second.tail_pocket = p->first;
    }
  }
}

///////////////////////////////////////////////////////////////////////////////
// Roadmoveؿ
void RealMap::move_normal(Id k)
{
  // Ƭ֤ʤmove_front,³֤ʤ֤ɽ
  SimCars::iterator p = sim_car.find(k);
  // Ƭ
  if(p->second.front_id==NP)        move_front(p->first);
  // ³
  else{
	// ®ٷBEGIN
    if((p->second.speed>=(MAX_SPEED-ACCELERATION)*1000) && 
	   (p->second.between>=(MAX_SPEED+DIST_BET_CARS)*1000)) {
      p->second.speed = MAX_SPEED*1000;
    }else if((p->second.between-DIST_BET_CARS*1000)>=(p->second.speed+ACCELERATION*1000)){
      p->second.speed += ACCELERATION*1000;
    }else if(p->second.between >= DIST_BET_CARS*1000){
      p->second.speed = p->second.between - DIST_BET_CARS*1000;
    }else{
      p->second.speed = 0;
    }
	// ®ٷEND
    if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
    else                    p->second.positionExtra += p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in move_normal\n");
      exit(1);
    }
    p->second.between -= p->second.speed;
    if(p->second.back_id!=NP){
      SimCars::iterator back = sim_car.find(p->second.back_id);
      back->second.between += p->second.speed;
    }
  }
}

///////////////////////////////////////////////////////////////////////////////
// Ƭ֤moveؿ
void RealMap::move_front(Id k)
{
  // Roadưư(move_at_cross)ؤʬ
  SimCars::iterator p = sim_car.find(k);
  // Roadư
  if(p->second.speed>=(MAX_SPEED-ACCELERATION)*1000 && p->second.between>=MAX_SPEED*1000){
    p->second.speed = MAX_SPEED*1000;
    if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
    else                    p->second.positionExtra += p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in move_front\n");
      exit(1);
    }
    p->second.between -= p->second.speed;
    if(p->second.back_id!=NP){
      SimCars::iterator back = sim_car.find(p->second.back_id);
      back->second.between += p->second.speed;
    }
  }else if(p->second.between>=p->second.speed+ACCELERATION*1000){
    p->second.speed += ACCELERATION*1000;
    if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
    else                    p->second.positionExtra += p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in move_front\n");
      exit(1);
    }
    p->second.between -= p->second.speed;
    if(p->second.back_id!=NP){
      SimCars::iterator back = sim_car.find(p->second.back_id);
      back->second.between += p->second.speed;
    }
  }else{
    // ư
    move_at_cross(p->first);
  }
}

///////////////////////////////////////////////////////////////////////////////
// Ǥΰưؿ
void RealMap::move_at_cross(Id k)
{
  // ɸΡãξν->ưλ
  // Ϣξν->ưλ
  // 椬(move_signal)Ȥʤ(move_no_signal)ؤʬ
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  // ɸΡɤã
  if((p->second.aim_num == p->second.step+2) ||
     (p->second.aim_num == p->second.step+1)) {	// MA(00/06/08)
		p->second.speed = p->second.between;
		p->second.between = 0;
		if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
		else p->second.positionExtra += p->second.speed;
		if(p->second.positionExtra<0){
			printf("positionExtra error in move_at_cross\n");
			exit(1);
		}
		if(p->second.back_id!=NP){
			SimCars::iterator back = sim_car.find(p->second.back_id);
			if(p->second.direct==HEAD) back->second.between=back->second.positionExtra;
			else{ 
				back->second.between = 
					now->second.pointer->length() - back->second.positionExtra;
			}
			back->second.front_id = NP;
		}else{
			if(p->second.direct==HEAD) now->second.head_last_id[p->second.line] = NP;
			else                    now->second.tail_last_id[p->second.line] = NP;
		}
		if(p->second.direct==HEAD) p->second.position = now->second.head;
		else                    p->second.position = now->second.tail;
		p->second.back_id = NP;
		p->second.motion = 2;
#ifdef DEBUG
		printf("reached to goal: %d\n", k);
#endif
  }else{
    SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
    int access = getAccess(now->first,next->first);
    // Υɤ->üΥΡɤޤǰư
    if(access==ILLEGAL){
      p->second.speed = p->second.between;
      p->second.between = 0;
      if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
      else                    p->second.positionExtra += p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_at_cross\n");
		exit(1);
      }
      if(p->second.back_id!=NP){
		SimCars::iterator back = sim_car.find(p->second.back_id);
		if(p->second.direct==HEAD){
		  back->second.between=back->second.positionExtra;
		}else{
		  back->second.between = now->second.pointer->length() - p->second.positionExtra;
		}
		back->second.front_id = NP;
      }else{
		if(p->second.direct==HEAD) now->second.head_last_id[p->second.line] = NP;
		else                    now->second.tail_last_id[p->second.line] = NP;
      }
	  // following 2 lines are added at 000717
      if(p->second.direct==HEAD) p->second.position = now->second.head;
      else p->second.position = now->second.tail;

      p->second.back_id = NP;
      p->second.motion = 2;
#ifdef DEBUG
      printf("Aim sequence is inconsistent: %d\n", k);
#endif
    }else{
      SimNodes::iterator node_id;
      if(p->second.direct==HEAD){
		node_id = sim_node.find(now->second.head);
      }else{
		node_id = sim_node.find(now->second.tail);
      }
      if(node_id->second.pointer->signal()==1){
		move_signal(p->first);
      }else{
		move_no_signal(p->first);
      }
    }
  }
}

///////////////////////////////////////////////////////////////////////////////
// 椬̵moveؿ
void RealMap::move_no_signal(Id k)
{
  // Ǥϰ
  // θΰư(move_node)ʬ
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimNodes::iterator node_id = sim_node.find(p->second.aim[p->second.step+1]);
  if(node_id->second.connect_road_num>=3){
    //
    if(p->second.between==0 && p->second.speed==0){
      move_node(p->first);
    }else if(p->second.between==0){
      p->second.speed = 0;
    }else{
      p->second.speed = p->second.between;
      p->second.between = 0;
      if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
      else                    p->second.positionExtra += p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_no_signal\n");
		exit(1);
      }
      if(p->second.back_id!=NP){
		SimCars::iterator back = sim_car.find(p->second.back_id);
		back->second.between += p->second.speed;
      }
    }
  }else{
    move_node(p->first);
  }
}

///////////////////////////////////////////////////////////////////////////////
// Ρɤؤmoveؿ
void RealMap::move_node(Id k)
{
  // Ƚ,Ԥʤа
  // Ԥ,ΡɤۤƤΰư(move_inroad)ʬ
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
  int alive,lines,access,judge;

  if(p->second.aim[p->second.step+1]==next->second.head){
    lines = next->second.pointer->linesToTail();
    alive = next->second.linesAliveTail;
  }else{
    lines = next ->second.pointer->linesToHead();
    alive = next->second.linesAliveHead;
  }
  if(alive==0){
    // 
    p->second.speed = p->second.between;
    p->second.between = 0;
    if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
    else                    p->second.positionExtra += p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in move_node\n");
      exit(1);
    }
    if(p->second.back_id!=NP){
      SimCars::iterator back = sim_car.find(p->second.back_id);
      back->second.between += p->second.speed;
    }
  }else{
    // ޤи
    access = getAccess(now->first,next->first);
	if(access == ILLEGAL || access == UNDEFINED) {
		printf("Warning: route plan is invalid.\n");
		ferrout << "Warning in move_node: invalid route plan for the car " 
			<< p->first << " at " << now->first << "->" << next->first << "\n" << std::flush;
		access = STRAIGHT; // 
		return; // 00/12/28
	//	exit(1);
	}
	int against = 0;
    against = judgeOncomingCar(p->first);
    if(access==RIGHT && against==1){
      // 
      p->second.speed = p->second.between;
      p->second.between = 0;
      if(p->second.direct==0) p->second.positionExtra -= p->second.speed;
      else                    p->second.positionExtra += p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_node\n");
		exit(1);
      }
      if(p->second.back_id!=NP){
	SimCars::iterator back = sim_car.find(p->second.back_id);
	back->second.between += p->second.speed;
      }
    }else{ // LEFT, STRAIGHT, RIGHT without oncoming cars
      // κǸ
      judge = judgeInroad(p->first);
      if(judge==1){
	move_inroad(p->first);
      }else{
	// 
	p->second.speed = p->second.between;
	p->second.between = 0;
	if(p->second.direct==0) p->second.positionExtra -= p->second.speed;
	else                    p->second.positionExtra += p->second.speed;
	if(p->second.positionExtra<0){
	  printf("positionExtra error in move_node\n");
	  exit(1);
	}
	if(p->second.back_id!=NP){
	  SimCars::iterator back = sim_car.find(p->second.back_id);
	  back->second.between += p->second.speed;
	}
      }
    }
  }
}

///////////////////////////////////////////////////////////////////////////////
// ؿ
void RealMap::move_inroad(Id k)
{
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
  SimNodes::iterator passNode;
  // ȼοʹ(RIGHT,LEFT,STRAIGHT)
  int *go = getLineInroad(p->first);
  int line = go[0];
  int dir = go[1];
  // ɤ˴ؤ
  if(p->second.back_id != NP){
    SimCars::iterator back = sim_car.find(p->second.back_id);
    if(p->second.direct==HEAD){
      back->second.between = back->second.positionExtra;
    }else{
      back->second.between =
	now->second.pointer->length() - back->second.positionExtra;
    }
    back->second.front_id = NP;
  }else{
    if(p->second.direct==HEAD){
      if(p->second.pocket==0){
		now->second.head_last_id[p->second.line] = NP;
      }else{
		now->second.head_pocket = NP;
		p->second.pocket = 0;
      }
    }else{
      if(p->second.pocket==0){
		now->second.tail_last_id[p->second.line] = NP;
      }else{
		now->second.tail_pocket = NP;
		p->second.pocket = 0;
      }
    }
  }
  // ɤ˴ؤ
  SimNodes::iterator node_id; // new
  int con; // new
  int offset; // new
  p->second.back_id = NP;
  if(p->second.aim[p->second.step+1]==next->second.tail) { // go to head
	passNode = sim_node.find(next->second.tail);
    node_id = sim_node.find(next->second.head); // new
    con = next->second.head_connect_num; // new
    if(next->second.head_last_id[line]==NP) { // no cars
	  if((dir==RIGHT) && node_id->second.pocketToTurnAcross.size()!=0 &&
		  node_id->second.pocketToTurnAcross[con*2]>=1) {
		if((p->second.speed>=(MAX_SPEED-ACCELERATION)*1000) && 
		   (p->second.between + next->second.pointer->length()-
		    node_id->second.pocketToTurnAcross[(con*2)+1] >= MAX_SPEED*1000)){
			p->second.speed = MAX_SPEED*1000;
		}else if((p->second.between + next->second.pointer->length()
			     - node_id->second.pocketToTurnAcross[(con*2)+1]) >=
				 (p->second.speed + ACCELERATION*1000)) {
			p->second.speed += ACCELERATION*1000;
		}else{
			p->second.speed = p->second.between + next->second.pointer->length()
				              - node_id->second.pocketToTurnAcross[(con*2)+1];
		}
	  } else { // LEFT, STRAIGHT, or RIGHT without pocket
		if(p->second.speed>=(MAX_SPEED-ACCELERATION)*1000 && 
			p->second.between + next->second.pointer->length() >= MAX_SPEED*1000){
			p->second.speed = MAX_SPEED*1000;
		}else if(p->second.between + next->second.pointer->length() >=
				(p->second.speed + ACCELERATION*1000)){
			p->second.speed += ACCELERATION*1000;
		}else{
			p->second.speed = p->second.between + next->second.pointer->length();
		}
	  }
	  p->second.positionExtra = next->second.pointer->length() + 
                                  p->second.between - p->second.speed;
	  if(p->second.positionExtra<0){
		printf("positionExtra error in move_inroad(1)\n");
		exit(1);
	  }
	  p->second.front_id = NP;
	  p->second.between = p->second.positionExtra;
    }else{ // exist cars
      SimCars::iterator last = sim_car.find(next->second.head_last_id[line]);
	  if((dir==RIGHT) && node_id->second.pocketToTurnAcross.size()!=0 &&
		  node_id->second.pocketToTurnAcross[con*2]>=1) {
		  if(last->second.positionExtra > node_id->second.pocketToTurnAcross[(con*2)+1])
			offset = last->second.positionExtra;
		  else offset = node_id->second.pocketToTurnAcross[(con*2)+1];
	  } else { // LEFT, STRAIGHT or RIGHT without pocket
			offset = last->second.positionExtra;
	  }
	  if(p->second.speed>=(MAX_SPEED-ACCELERATION)*1000 && 
		 p->second.between + next->second.pointer->length() - 
		 offset - DIST_BET_CARS*1000>=MAX_SPEED*1000){
			p->second.speed = MAX_SPEED*1000;
	  }else if(p->second.between + next->second.pointer->length() - 
	           offset - DIST_BET_CARS*1000 >= p->second.speed+ACCELERATION*1000){
			p->second.speed += ACCELERATION*1000;
	  }else if(p->second.between + next->second.pointer->length() -
	            offset >= DIST_BET_CARS*1000){
			p->second.speed = p->second.between + next->second.pointer->length() -
		                      offset - DIST_BET_CARS*1000;
	  } else { // may occur in case of RIGHT with pocket
			p->second.speed = p->second.between + next->second.pointer->length() - offset;
	  }
	  if(p->second.speed < p->second.between) p->second.speed = p->second.between;
															// ɤˤɬ
      p->second.positionExtra = next->second.pointer->length() + 
								p->second.between - p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_inroad(2)\n");
		exit(1);
      }
      p->second.between = p->second.positionExtra - last->second.positionExtra;
      p->second.front_id = last->first;
      last->second.back_id = p->first;
    }
    next->second.head_last_id[line] = p->first;
    p->second.direct = HEAD;
  }else{ // go to tail
	passNode = sim_node.find(next->second.head);
    node_id = sim_node.find(next->second.tail); // new
    con = next->second.tail_connect_num; // new
    if(next->second.tail_last_id[line]==NP){ // no cars
	  if((dir==RIGHT) && node_id->second.pocketToTurnAcross.size()!=0 &&
		  node_id->second.pocketToTurnAcross[con*2]>=1) {
		if(p->second.speed>=(MAX_SPEED-ACCELERATION)*1000 && 
		   (p->second.between + next->second.pointer->length() -
		   node_id->second.pocketToTurnAcross[(con*2)+1]) >= MAX_SPEED*1000){
			p->second.speed = MAX_SPEED*1000;
		}else if((p->second.between + next->second.pointer->length() -
			     node_id->second.pocketToTurnAcross[(con*2)+1]) >= 
				 (p->second.speed + ACCELERATION*1000)) {
			p->second.speed += ACCELERATION*1000;
		}else{
			p->second.speed = p->second.between + next->second.pointer->length() -
				              node_id->second.pocketToTurnAcross[(con*2)+1];
		}
	  } else { // LEFT, STRAIGHT or RIGHT without pocket
		if(p->second.speed>=(MAX_SPEED-ACCELERATION)*1000 && 
		   p->second.between + next->second.pointer->length() >= MAX_SPEED*1000){
			p->second.speed = MAX_SPEED*1000;
		}else if(p->second.between + next->second.pointer->length() >= p->second.speed + ACCELERATION*1000){
			p->second.speed += ACCELERATION*1000;
		}else{
			p->second.speed = p->second.between + next->second.pointer->length();
		}
	  }
      p->second.positionExtra = p->second.speed - p->second.between;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_inroad(3)\n");
		exit(1);
      }
	  p->second.front_id = NP;
      p->second.between = next->second.pointer->length() - p->second.positionExtra;
    }else{ // exist cars
      SimCars::iterator last = sim_car.find(next->second.tail_last_id[line]);
	  if((dir==RIGHT) && node_id->second.pocketToTurnAcross.size()!=0 &&
		  node_id->second.pocketToTurnAcross[con*2]>=1) {
		  int across = next->second.pointer->length() - 
			           node_id->second.pocketToTurnAcross[(con*2)+1];
		  if(last->second.positionExtra > across)
			offset = across;
		  else offset = last->second.positionExtra;
	  } else { // LEFT, STRAIGHT or RIGHT without pocket
			offset = last->second.positionExtra;
	  }
      if(p->second.speed>=(MAX_SPEED-ACCELERATION)*1000 && 
	     p->second.between + offset - DIST_BET_CARS*1000>=MAX_SPEED*1000){
		p->second.speed = MAX_SPEED*1000;
      }else if(p->second.between + offset - DIST_BET_CARS*1000 >= 
	           p->second.speed+ACCELERATION*1000){
		p->second.speed += ACCELERATION*1000;
      }else if(p->second.between + offset>=DIST_BET_CARS*1000){
		p->second.speed = p->second.between + offset - DIST_BET_CARS*1000;
      }else{ // may occur in case of RIGHT with pocket
		p->second.speed = p->second.between + offset;
      }
	  if(p->second.speed < p->second.between) p->second.speed = p->second.between;
															// ɤˤɬ
      p->second.positionExtra = p->second.speed - p->second.between;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_inroad(4)\n");
		printf("speed=%d, between=%d, offset=%d\n", p->second.speed, p->second.between, offset);
		exit(1);
      }
      p->second.between = last->second.positionExtra - p->second.positionExtra;
      p->second.front_id = last->first;
      last->second.back_id = p->first;
    }
    next->second.tail_last_id[line] = p->first;
    p->second.direct = TAIL;
  }
  p->second.line = line;
  p->second.position = next->first;
  if(POSITION_HISTORY) p->second.addPositionHistory(passNode->second.pointer);
  p->second.step += 2;
}

///////////////////////////////////////////////////////////////////////////////
// MA : ӥǥ󥰤ؤΰư
// aim := .... road node building
void RealMap::move_toward_building(Id k, Id bdg) {
	SimCars::iterator p = sim_car.find(k);

	// Ƭ
    if(p->second.front_id == NP) {
		// ϩư..same as move_front
		if(p->second.speed>=(MAX_SPEED-ACCELERATION)*1000 && p->second.between>=MAX_SPEED*1000){
			p->second.speed = MAX_SPEED*1000;
			if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
			else                    p->second.positionExtra += p->second.speed;
			if(p->second.positionExtra<0){
				printf("positionExtra error in move_front\n");
				exit(1);
			}
			p->second.between -= p->second.speed;
			if(p->second.back_id!=NP){
				SimCars::iterator back = sim_car.find(p->second.back_id);
				back->second.between += p->second.speed;
			}
		} else if(p->second.between>=p->second.speed+ACCELERATION*1000){
			p->second.speed += ACCELERATION*1000;
			if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
			else                    p->second.positionExtra += p->second.speed;
			if(p->second.positionExtra<0){
				printf("positionExtra error in move_front\n");
				exit(1);
			}
			p->second.between -= p->second.speed;
			if(p->second.back_id!=NP){
				SimCars::iterator back = sim_car.find(p->second.back_id);
				back->second.between += p->second.speed;
			}
		} else{  // ʪذư  .. modified based on move_at_cross
			SimRoads::iterator now = sim_road.find(p->second.position);
			p->second.speed = p->second.between;
			p->second.between = 0;
			if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
			else                    p->second.positionExtra += p->second.speed;
			if(p->second.positionExtra<0){
				printf("positionExtra error in move_at_cross\n");
				exit(1);
			}
			if(p->second.back_id!=NP){
				SimCars::iterator back = sim_car.find(p->second.back_id);
				if(p->second.direct==HEAD) back->second.between=back->second.positionExtra;
				else{ 
					back->second.between = 
						now->second.pointer->length() - back->second.positionExtra;
				}
				back->second.front_id = NP;
			}else{
				if(p->second.direct==HEAD) now->second.head_last_id[p->second.line] = NP;
				else                    now->second.tail_last_id[p->second.line] = NP;
			}
			// reached to node
			SimNodes::iterator passNode;
			if(p->second.direct==HEAD) {
				p->second.position = now->second.head;
				passNode = sim_node.find(now->second.head);
			}else {                   
				p->second.position = now->second.tail;
				passNode = sim_node.find(now->second.tail);
			}
			if(POSITION_HISTORY) p->second.addPositionHistory(passNode->second.pointer);
			// and enter building
			p->second.position = bdg;

			p->second.back_id = NP;
			p->second.motion = 2;
#ifdef DEBUG
			printf("reached to building: %d\n", k);
#endif
		}
	} else { // ³ .. same as move_normal
		if(p->second.speed>=(MAX_SPEED-ACCELERATION)*1000 && p->second.between-DIST_BET_CARS*1000>=MAX_SPEED*1000){
			p->second.speed = MAX_SPEED*1000;
		}else if(p->second.between-DIST_BET_CARS*1000>=p->second.speed+ACCELERATION*1000){
			p->second.speed += ACCELERATION*1000;
		}else if(p->second.between >= DIST_BET_CARS*1000){
			p->second.speed = p->second.between - DIST_BET_CARS*1000;
		}else{
			p->second.speed = 0;
		}
		if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
		else                    p->second.positionExtra += p->second.speed;
		if(p->second.positionExtra<0){
			printf("positionExtra error in move_normal\n");
			exit(1);
		}
		p->second.between -= p->second.speed;
		if(p->second.back_id!=NP){
			SimCars::iterator back = sim_car.find(p->second.back_id);
			back->second.between += p->second.speed;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// 椬moveؿ
void RealMap::move_signal(Id k)
{
  printf("move_signal");
  // ֿǥ硼ȥå̵ʤ
  // 硼ȥåȤʤ߸(move_node)
  // 㤦ʤĿ(move_on_blue)ؤʬ
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
  int con;
  SimNodes::iterator node_id;
  if(now->second.head==next->second.head || now->second.head==next->second.tail){
    node_id = sim_node.find(now->second.head);
    con = now->second.head_connect_num;
  }else{
    node_id = sim_node.find(now->second.tail);
    con = now->second.tail_connect_num;
  }
  if(0/* ֿ */){
    if(node_id->second.shortcutToTurn[con]>=1){
      // ޥ硼Ȥ
      if(p->second.between==0 && p->second.speed==0){
		move_node(p->first);
      }else if(p->second.between==0){
		p->second.speed = 0;
      }else{
		p->second.speed = p->second.between;
		p->second.between = 0;
		if(p->second.direct==0) p->second.positionExtra -= p->second.speed;
		else                    p->second.positionExtra += p->second.speed;
		if(p->second.positionExtra<0){
			printf("positionExtra error in move_signal\n");
			exit(1);
		}
		if(p->second.back_id!=NP){
			SimCars::iterator back = sim_car.find(p->second.back_id);
			back->second.between += p->second.speed;
		}
      }
    }else{
      // 
      p->second.speed = p->second.between;
      p->second.between = 0;
      if(p->second.direct==0) p->second.positionExtra -= p->second.speed;
      else                    p->second.positionExtra += p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_signal\n");
		exit(1);
      }
      if(p->second.back_id!=NP){
		SimCars::iterator back = sim_car.find(p->second.back_id);
		back->second.between += p->second.speed;
      }
    }
  }else{
    move_on_blue(p->first);
  }
}

///////////////////////////////////////////////////////////////////////////////
// ĿǤmoveؿ
void RealMap::move_on_blue(Id k)
{
  // Ŀ椫̤Ĥ
  // ֤ʤ鱦޿Ƚ(move_node_across)Ƚ(move_node)ʬ
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
  int con,access;
  if(now->second.head==next->second.head || now->second.head==next->second.tail){
    SimNodes::iterator node_id = sim_node.find(now->second.head);
    con = now->second.head_connect_num;
  }else{
    SimNodes::iterator node_id = sim_node.find(now->second.tail);
    con = now->second.tail_connect_num;
  }
  if(0/* Ŀ */){
    access = getAccess(now->first,next->first);
    if(access==0)      move_node_across(p->first);
    else{
      // 
      p->second.speed = p->second.between;
      p->second.between = 0;
      if(p->second.direct==0) p->second.positionExtra -= p->second.speed;
      else                    p->second.positionExtra += p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_on_blue\n");
		exit(1);
      }
      if(p->second.back_id!=NP){
		SimCars::iterator back = sim_car.find(p->second.back_id);
		back->second.between += p->second.speed;
      }
    }
  }else{
    // Ŀ
    move_node(p->first);
  }
}

///////////////////////////////////////////////////////////////////////////////
// Ŀ椫οȽ
void RealMap::move_node_across(Id k)
{
  // Ƚꡢǽʤп(move_inroad)
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
  int alive,lines,judge;
  if(p->second.aim[p->second.step+1]==next->second.head){
    lines = next->second.pointer->linesToTail();
    alive = next->second.linesAliveTail;
  }else{
    lines = next ->second.pointer->linesToHead();
    alive = next->second.linesAliveHead;
  }
  if(alive==0){
    // 
    p->second.speed = p->second.between;
    p->second.between = 0;
    if(p->second.direct==0) p->second.positionExtra -= p->second.speed;
    else                    p->second.positionExtra += p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in move_node_across\n");
      exit(1);
    }
    if(p->second.back_id!=NP){
      SimCars::iterator back = sim_car.find(p->second.back_id);
      back->second.between += p->second.speed;
    }
  }else{
    // κǸ
    judge = judgeInroad(p->first);
    if(judge==1){
      move_inroad(p->first);
    }else{
      // 
      p->second.speed = p->second.between;
      p->second.between = 0;
      if(p->second.direct==0) p->second.positionExtra -= p->second.speed;
      else                    p->second.positionExtra += p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_node_across\n");
		exit(1);
      }
      if(p->second.back_id!=NP){
		SimCars::iterator back = sim_car.find(p->second.back_id);
		back->second.between += p->second.speed;
      }
    }
  }
}

//////////////////////////////////////////////////////////////////////////////////