// simworld_personmove.cxx ... pedestrianmoveؿ

#include <stdio.h>
#include <stdlib.h>

#include "common.hxx"
#include "basic.hxx"
#include "Config.hxx"
#include "Address.hxx"
#include "Input.hxx"
#include "Output.hxx"
#include "LongUDPSocket.hxx"
#include "ObjectPool.hxx"
#include "objects.hxx"
#include "sim_class.h"
using namespace Rescue;

extern std::ofstream ferrout;

// moveؿ
void RealMap::pmove(Id move_id)
{
  // ư(pmove_normal),ʪư(pmove_to_building)ؤʬؿ
  SimCars::iterator p = sim_car.find(move_id);
  SimRoads::iterator now = sim_road.find(p->second.position);

  if((p->second.aim_num == p->second.step+2) || 
	 (p->second.aim_num == p->second.step+1)) { // MA(00/06/08)
		pmove_normal(p->first);
  } else {
		SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
		if(next == sim_road.end()) {
			// MA: aim[p->second.step+2] can be building and 
			// all procesing for building may be written here...ӥǥ󥰤ؤΰư
#ifdef DEBUG
			printf("#Building=%d#", p->second.aim[p->second.step+2]);
#endif
			pmove_toward_building(p->first, p->second.aim[p->second.step+2]);
			
		} else {
			pmove_normal(p->first);
		}
  }
  p->second.flag += 1;
}

///////////////////////////////////////////////////////////////////////////////
// Roadmoveؿ
void RealMap::pmove_normal(Id k)
{
  // Ƭʤpmove_front,³ʤɽ
  SimCars::iterator p = sim_car.find(k);
  // Ƭ
  if(p->second.front_id==NP)        pmove_front(p->first);
  // ³
  else{
	// ®ٷBEGIN
    if((p->second.speed>=(PMAX_SPEED-PACCELERATION)*1000) && 
	   (p->second.between>=(PMAX_SPEED+DIST_BET_PEDESTRIANS)*1000)) {
      p->second.speed = (S32)(PMAX_SPEED*1000);
    }else if((p->second.between-DIST_BET_PEDESTRIANS*1000)>=(p->second.speed+PACCELERATION*1000)){
      p->second.speed += (S32)(PACCELERATION*1000);
    }else if(p->second.between >= DIST_BET_PEDESTRIANS*1000){
      p->second.speed = p->second.between - DIST_BET_PEDESTRIANS*1000;
    }else{
      p->second.speed = 0;
    }
	// ®ٷEND
    if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
    else                    p->second.positionExtra += p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in pmove_normal\n");
      exit(1);
    }
    p->second.between -= p->second.speed;
    if(p->second.back_id!=NP){
      SimCars::iterator back = sim_car.find(p->second.back_id);
      back->second.between += p->second.speed;
    }
  }
}

///////////////////////////////////////////////////////////////////////////////
// Ƭ֤moveؿ
void RealMap::pmove_front(Id k)
{
  // Roadưư(pmove_at_cross)ؤʬ
  SimCars::iterator p = sim_car.find(k);
  // Roadư
  if(p->second.speed>=(PMAX_SPEED-PACCELERATION)*1000 && p->second.between>=PMAX_SPEED*1000){
    p->second.speed = (S32)(PMAX_SPEED*1000);
    if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
    else                    p->second.positionExtra += p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in pmove_front\n");
      exit(1);
    }
    p->second.between -= p->second.speed;
    if(p->second.back_id!=NP){
      SimCars::iterator back = sim_car.find(p->second.back_id);
      back->second.between += p->second.speed;
    }
  }else if(p->second.between>=p->second.speed+PACCELERATION*1000){
    p->second.speed += (S32)(PACCELERATION*1000);
    if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
    else                    p->second.positionExtra += p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in pmove_front\n");
      exit(1);
    }
    p->second.between -= p->second.speed;
    if(p->second.back_id!=NP){
      SimCars::iterator back = sim_car.find(p->second.back_id);
      back->second.between += p->second.speed;
    }
  }else{
    // ư
    pmove_at_cross(p->first);
  }
}

///////////////////////////////////////////////////////////////////////////////
// Ǥΰưؿ
void RealMap::pmove_at_cross(Id k)
{
  // ɸΡãξν->ưλ
  // Ϣξν->ưλ
  // 椬(pmove_signal)Ȥʤ(pmove_no_signal)ؤʬ
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  // ɸΡɤã
  if((p->second.aim_num == p->second.step+2) ||
     (p->second.aim_num == p->second.step+1)) {	// MA(00/06/08)
    p->second.speed = p->second.between;
    p->second.between = 0;
    if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
    else p->second.positionExtra += p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in move_at_cross\n");
      exit(1);
    }
    if(p->second.back_id!=NP){
      SimCars::iterator back = sim_car.find(p->second.back_id);
      if(p->second.direct==HEAD) back->second.between=back->second.positionExtra;
      else{ 
		back->second.between = now->second.pointer->length() - back->second.positionExtra;
      }
      back->second.front_id = NP;
    }else{
      if(p->second.direct==HEAD) now->second.phead_last_id[p->second.line] = NP;
      else                    now->second.ptail_last_id[p->second.line] = NP;
    }
    if(p->second.direct==HEAD) p->second.position = now->second.head;
    else                    p->second.position = now->second.tail;
    p->second.back_id = NP;
    p->second.motion = 2;
#ifdef DEBUG
    printf("reached to goal: %d\n", k);
#endif
  }else{
    SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
    int access = getAccess(now->first,next->first);
    // Υɤ->üΥΡɤޤǰư
    if(access==ILLEGAL){
      p->second.speed = p->second.between;
      p->second.between = 0;
      if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
      else                    p->second.positionExtra += p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_at_cross\n");
		exit(1);
      }
      if(p->second.back_id!=NP){
		SimCars::iterator back = sim_car.find(p->second.back_id);
		if(p->second.direct==HEAD){
			back->second.between=back->second.positionExtra;
		}else{
			back->second.between = now->second.pointer->length() - p->second.positionExtra;
		}
		back->second.front_id = NP;
      }else{
		if(p->second.direct==HEAD) now->second.phead_last_id[p->second.line] = NP;
		else                    now->second.ptail_last_id[p->second.line] = NP;
      }
	  // following 2 lines are added at 000717
      if(p->second.direct==HEAD) p->second.position = now->second.head;
      else p->second.position = now->second.tail;

      p->second.back_id = NP;
      p->second.motion = 2;
#ifdef DEBUG
      printf("Aim sequence is inconsistent: %d\n", k);
#endif
    }else{
      SimNodes::iterator node_id;
      if(p->second.direct==HEAD){
		node_id = sim_node.find(now->second.head);
      }else{
		node_id = sim_node.find(now->second.tail);
      }
      if(node_id->second.pointer->signal()==1){
		pmove_signal(p->first);
      }else{
		pmove_no_signal(p->first);
      }
    }
  }
}

///////////////////////////////////////////////////////////////////////////////
// 椬̵moveؿ
void RealMap::pmove_no_signal(Id k)
{
  // Ǥϰ
  // θΰư(pmove_node)ʬ
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimNodes::iterator node_id = sim_node.find(p->second.aim[p->second.step+1]);
  if(node_id->second.connect_road_num>=3){
    //
    if(p->second.between==0 && p->second.speed==0){
      pmove_node(p->first);
    }else if(p->second.between==0){
      p->second.speed = 0;
    }else{
      p->second.speed = p->second.between;
      p->second.between = 0;
      if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
      else                    p->second.positionExtra += p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_no_signal\n");
		exit(1);
      }
      if(p->second.back_id!=NP){
		SimCars::iterator back = sim_car.find(p->second.back_id);
		back->second.between += p->second.speed;
      }
    }
  }else{
    pmove_node(p->first);
  }
}

///////////////////////////////////////////////////////////////////////////////
// Ρɤؤmoveؿ
void RealMap::pmove_node(Id k)
{
  // Ƚ,Ԥʤа
  // Ԥ,ΡɤۤƤΰư(pmove_inroad)ʬ
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
  int alive,access,judge;

  if(p->second.aim[p->second.step+1]==next->second.head){
    alive = next->second.linesAliveTail;
  }else{
    alive = next->second.linesAliveHead;
  }
  if(alive==0){
    // 
    p->second.speed = p->second.between;
    p->second.between = 0;
    if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
    else                    p->second.positionExtra += p->second.speed;
    if(p->second.positionExtra<0){
      printf("positionExtra error in move_node\n");
      exit(1);
    }
    if(p->second.back_id!=NP){
      SimCars::iterator back = sim_car.find(p->second.back_id);
      back->second.between += p->second.speed;
    }
  }else{
    // ޤи
    access = getAccess(now->first,next->first);
	if(access == ILLEGAL || access == UNDEFINED) {
		printf("Warning: route plan is invalid.\n");
		ferrout << "Warning in pmove_node: invalid route plan for the car " 
			<< p->first << " at " << now->first << "->" << next->first << "\n" << std::flush;
		access = STRAIGHT; // 
		return; // 00/12/28
	//	exit(1);
	}
	int against = 0;
    against = judgeOncomingCar(p->first);
    if(access==RIGHT && against==1){
      // 
      p->second.speed = p->second.between;
      p->second.between = 0;
      if(p->second.direct==0) p->second.positionExtra -= p->second.speed;
      else                    p->second.positionExtra += p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in move_node\n");
		exit(1);
      }
      if(p->second.back_id!=NP){
		SimCars::iterator back = sim_car.find(p->second.back_id);
		back->second.between += p->second.speed;
      }
    }else{ // LEFT, STRAIGHT, RIGHT without oncoming cars
      // κǸ
      judge = pjudgeInroad(p->first);
      if(judge==1){
		pmove_inroad(p->first);
      }else{
		// 
		p->second.speed = p->second.between;
		p->second.between = 0;
		if(p->second.direct==0) p->second.positionExtra -= p->second.speed;
		else                    p->second.positionExtra += p->second.speed;
		if(p->second.positionExtra<0){
			printf("positionExtra error in move_node\n");
			exit(1);
		}
		if(p->second.back_id!=NP){
			SimCars::iterator back = sim_car.find(p->second.back_id);
			back->second.between += p->second.speed;
		}
      }
    }
  }
}

///////////////////////////////////////////////////////////////////////////////
// ؿ
void RealMap::pmove_inroad(Id k)
{
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
  SimNodes::iterator passNode;
  // ȼοʹ(RIGHT,LEFT,STRAIGHT)
  int *go = pgetLineInroad(p->first);
  int line = go[0];
  int dir = go[1];
  // ɤ˴ؤ
  if(p->second.back_id != NP){
    SimCars::iterator back = sim_car.find(p->second.back_id);
    if(p->second.direct==HEAD){
      back->second.between = back->second.positionExtra;
    }else{
      back->second.between =
	now->second.pointer->length() - back->second.positionExtra;
    }
    back->second.front_id = NP;
  }else{
    if(p->second.direct == HEAD) {
		now->second.phead_last_id[p->second.line] = NP;
    }else{
 		now->second.ptail_last_id[p->second.line] = NP;
    }
  }
  // ɤ˴ؤ
  int offset; // new
  p->second.back_id = NP;
  if(p->second.aim[p->second.step+1]==next->second.tail) { // go to head
	passNode = sim_node.find(next->second.tail);
    if(next->second.phead_last_id[line]==NP) { // no pedestrians
	    // LEFT, STRAIGHT, or RIGHT
		if(p->second.speed>=(PMAX_SPEED-PACCELERATION)*1000 && 
			p->second.between + next->second.pointer->length() >= PMAX_SPEED*1000){
			p->second.speed = (S32)(PMAX_SPEED*1000);
		}else if(p->second.between + next->second.pointer->length() >=
				(p->second.speed + PACCELERATION*1000)){
			p->second.speed += (S32)(PACCELERATION*1000);
		}else{
			p->second.speed = p->second.between + next->second.pointer->length();
		}
		p->second.positionExtra = next->second.pointer->length() + 
                                  p->second.between - p->second.speed;
		if(p->second.positionExtra<0){
			printf("positionExtra error in pmove_inroad(1)\n");
			exit(1);
		}
		p->second.front_id = NP;
		p->second.between = p->second.positionExtra;
    }else{ // exist pedestrians
      SimCars::iterator last = sim_car.find(next->second.phead_last_id[line]);
	  // LEFT, STRAIGHT or RIGHT
	  offset = last->second.positionExtra;
	  if(p->second.speed>=(PMAX_SPEED-PACCELERATION)*1000 && 
		 p->second.between + next->second.pointer->length() - 
		 offset - DIST_BET_PEDESTRIANS*1000>=PMAX_SPEED*1000){
			p->second.speed = (S32)(PMAX_SPEED*1000);
	  }else if(p->second.between + next->second.pointer->length() - 
	           offset - DIST_BET_PEDESTRIANS*1000 >= p->second.speed+PACCELERATION*1000){
			p->second.speed += (S32)(PACCELERATION*1000);
	  }else if(p->second.between + next->second.pointer->length() -
	            offset >= DIST_BET_PEDESTRIANS*1000){
			p->second.speed = p->second.between + next->second.pointer->length() -
		                      offset - DIST_BET_PEDESTRIANS*1000;
	  } else { // should not occur
			p->second.speed = p->second.between + next->second.pointer->length() - offset;
	  }
	  if(p->second.speed < p->second.between) p->second.speed = p->second.between;
															// ɤˤɬ
      p->second.positionExtra = next->second.pointer->length() + 
								p->second.between - p->second.speed;
      if(p->second.positionExtra<0){
		printf("positionExtra error in pmove_inroad(2)\n");
		exit(1);
      }
      p->second.between = p->second.positionExtra - last->second.positionExtra;
      p->second.front_id = last->first;
      last->second.back_id = p->first;
    }
    next->second.phead_last_id[line] = p->first;
    p->second.direct = HEAD;
  }else{ // go to tail
	passNode = sim_node.find(next->second.head);
    if(next->second.ptail_last_id[line]==NP){ // no pedestrians
		// LEFT, STRAIGHT or RIGHT
		if(p->second.speed>=(PMAX_SPEED-PACCELERATION)*1000 && 
		   p->second.between + next->second.pointer->length() >= PMAX_SPEED*1000){
			p->second.speed = (S32)(PMAX_SPEED*1000);
		}else if(p->second.between + next->second.pointer->length() >= p->second.speed + PACCELERATION*1000){
			p->second.speed += (S32)(PACCELERATION*1000);
		}else{
			p->second.speed = p->second.between + next->second.pointer->length();
		}
		p->second.positionExtra = p->second.speed - p->second.between;
		if(p->second.positionExtra<0){
			printf("positionExtra error in pmove_inroad(3)\n");
			exit(1);
		}
		p->second.front_id = NP;
		p->second.between = next->second.pointer->length() - p->second.positionExtra;
    }else{ // exist pedestrians
      SimCars::iterator last = sim_car.find(next->second.ptail_last_id[line]);
	  // LEFT, STRAIGHT or RIGHT
	  offset = last->second.positionExtra;
      if(p->second.speed>=(PMAX_SPEED-PACCELERATION)*1000 && 
	     p->second.between + offset - DIST_BET_PEDESTRIANS*1000>=PMAX_SPEED*1000){
		p->second.speed = (S32)(PMAX_SPEED*1000);
      }else if(p->second.between + offset - DIST_BET_PEDESTRIANS*1000 >= 
	           p->second.speed+PACCELERATION*1000){
		p->second.speed += (S32)(PACCELERATION*1000);
      }else if(p->second.between + offset>=DIST_BET_PEDESTRIANS*1000){
		p->second.speed = p->second.between + offset - DIST_BET_PEDESTRIANS*1000;
      }else{ // should not occur
		p->second.speed = p->second.between + offset;
      }
	  if(p->second.speed < p->second.between) p->second.speed = p->second.between;
															// ɤˤɬ
      p->second.positionExtra = p->second.speed - p->second.between;
      if(p->second.positionExtra<0){
		printf("positionExtra error in pmove_inroad(4)\n");
		printf("speed=%d, between=%d, offset=%d\n", p->second.speed, p->second.between, offset);
		exit(1);
      }
      p->second.between = last->second.positionExtra - p->second.positionExtra;
      p->second.front_id = last->first;
      last->second.back_id = p->first;
    }
    next->second.ptail_last_id[line] = p->first;
    p->second.direct = TAIL;
  }
  p->second.line = line;
  p->second.position = next->first;
  if(POSITION_HISTORY) p->second.addPositionHistory(passNode->second.pointer);
  p->second.step += 2;
}

///////////////////////////////////////////////////////////////////////////////
// MA : ӥǥ󥰤ؤΰư
// aim := .... road node building
void RealMap::pmove_toward_building(Id k, Id bdg) {
	SimCars::iterator p = sim_car.find(k);

	// Ƭ
    if(p->second.front_id == NP) {
		// ϩư..same as pmove_front
		if(p->second.speed>=(PMAX_SPEED-PACCELERATION)*1000 && p->second.between>=PMAX_SPEED*1000){
			p->second.speed = (S32)(PMAX_SPEED*1000);
			if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
			else                    p->second.positionExtra += p->second.speed;
			if(p->second.positionExtra<0){
				printf("positionExtra error in pmove_toward_building\n");
				exit(1);
			}
			p->second.between -= p->second.speed;
			if(p->second.back_id!=NP){
				SimCars::iterator back = sim_car.find(p->second.back_id);
				back->second.between += p->second.speed;
			}
		} else if(p->second.between>=p->second.speed+PACCELERATION*1000){
			p->second.speed += (S32)(PACCELERATION*1000);
			if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
			else                    p->second.positionExtra += p->second.speed;
			if(p->second.positionExtra<0){
				printf("positionExtra error in pmove_toward_building\n");
				exit(1);
			}
			p->second.between -= p->second.speed;
			if(p->second.back_id!=NP){
				SimCars::iterator back = sim_car.find(p->second.back_id);
				back->second.between += p->second.speed;
			}
		} else{  // ʪذư  .. modified based on pmove_at_cross
			SimRoads::iterator now = sim_road.find(p->second.position);
			p->second.speed = p->second.between;
			p->second.between = 0;
			if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
			else                    p->second.positionExtra += p->second.speed;
			if(p->second.positionExtra<0){
				printf("positionExtra error in pmove_toward_building\n");
				exit(1);
			}
			if(p->second.back_id!=NP){
				SimCars::iterator back = sim_car.find(p->second.back_id);
				if(p->second.direct==HEAD) back->second.between=back->second.positionExtra;
				else{ 
					back->second.between = 
						now->second.pointer->length() - back->second.positionExtra;
				}
				back->second.front_id = NP;
			}else{
				if(p->second.direct==HEAD) now->second.phead_last_id[p->second.line] = NP;
				else                    now->second.ptail_last_id[p->second.line] = NP;
			}
			// reached to node
			SimNodes::iterator passNode;
			if(p->second.direct==HEAD) {
				p->second.position = now->second.head;
				passNode = sim_node.find(now->second.head);
			} else {                    
				p->second.position = now->second.tail;
				passNode = sim_node.find(now->second.tail);
			}
			if(POSITION_HISTORY) p->second.addPositionHistory(passNode->second.pointer);
			// and enter building
			p->second.position = bdg;

			p->second.back_id = NP;
			p->second.motion = 2;
#ifdef DEBUG
			printf("reached to building: %d\n", k);
#endif
		}
	} else { // ³ .. same as pmove_normal
		if(p->second.speed>=(PMAX_SPEED-PACCELERATION)*1000 && p->second.between-DIST_BET_PEDESTRIANS*1000>=PMAX_SPEED*1000){
			p->second.speed = (S32)(PMAX_SPEED*1000);
		}else if(p->second.between-DIST_BET_PEDESTRIANS*1000>=p->second.speed+PACCELERATION*1000){
			p->second.speed += (S32)(PACCELERATION*1000);
		}else if(p->second.between >= DIST_BET_PEDESTRIANS*1000){
			p->second.speed = p->second.between - DIST_BET_PEDESTRIANS*1000;
		}else{
			p->second.speed = 0;
		}
		if(p->second.direct==HEAD) p->second.positionExtra -= p->second.speed;
		else                    p->second.positionExtra += p->second.speed;
		if(p->second.positionExtra<0){
			printf("positionExtra error in pmove_toward_building\n");
			exit(1);
		}
		p->second.between -= p->second.speed;
		if(p->second.back_id!=NP){
			SimCars::iterator back = sim_car.find(p->second.back_id);
			back->second.between += p->second.speed;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// 椬moveؿ
void RealMap::pmove_signal(Id k)
{
  printf("move_signal");
  // ֿľʡޤʤ
  // ʳʤpmove_nodeʬ
  SimCars::iterator p = sim_car.find(k);
  SimRoads::iterator now = sim_road.find(p->second.position);
  SimRoads::iterator next = sim_road.find(p->second.aim[p->second.step+2]);
  if(0/* ֿ */){
		int access = getAccess(now->first,next->first);
		if(access==LEFT)      pmove_node(p->first);
		else {	
			// 
			p->second.speed = p->second.between;
			p->second.between = 0;
			if(p->second.direct==0) p->second.positionExtra -= p->second.speed;
			else                    p->second.positionExtra += p->second.speed;
			if(p->second.positionExtra<0){
				printf("positionExtra error in pmove_signal\n");
				// exit(1);
			}
			if(p->second.back_id!=NP){
				SimCars::iterator back = sim_car.find(p->second.back_id);
				back->second.between += p->second.speed;
			}
		}
  } else {
		pmove_node(p->first);
  }
}

//////////////////////////////////////////////////////////////////////////////////
