/***********************************************
 * simworld_traffic.cxx
 * --------------------------------------------
 * 1 minite  traffic simulation
 * --------------------------------------------
 *  RealMap::traffic()
 ***********************************************/

#include "common.hxx"
#include "basic.hxx"
#include "Config.hxx"
#include "Address.hxx"
#include "Input.hxx"
#include "Output.hxx"
#include "LongUDPSocket.hxx"
#include "ObjectPool.hxx"
#include "objects.hxx"
#include "sim_class.h"
using namespace Rescue;

void RealMap::traffic()
{
	int max, process, movable;
	SimCars::iterator p, argmax;
	
	for(int sec=0; sec<60; sec++){
#ifdef DEBUG
		printf(" %d", sec);
#endif
		movable = 0;
		while(1){
			process = 0; max = 0;
			for(p=sim_car.begin(); p!=sim_car.end(); p++){
				if(p->second.motion == 1) {
					movable = 1;
					if(p->second.flag == sec){
						process = 1;
						if(p->second.between >= max){
							argmax = p;
							max = p->second.between;
						} else if(p->second.between < 0){
							printf("error: sec=%d car=%d between=%d\n",
								    sec, p->first, p->second.between);
  							exit(1);
						}
					}
				}
			}
			if(process == 0)  break;
			else{
				try {	// for catching unknown exception in Windows
					if((argmax->second).isPedestrian()) {
#ifdef DEBUG
						printf("PEDESTRIAN:%d\n", argmax->first);
#endif
						pmove((Id)argmax->first); 
					} else {
#ifdef DEBUG
						printf("CAR:%d\n", argmax->first);
#endif
						move((Id)argmax->first); 
					}
				} catch(...) {
					printf("X");
		 			argmax->second.flag += 1;
				}
			}
		}
		if(movable == 0) break;
		/* 000717 call every second --> only call every minite
		InitLines(); 
		InitFront(); 
		InitRoad();
		*/
	}
#ifdef DEBUG
	printf("\n");
#endif
}

//////////////////////////////////////////////////////////////////////